/*
 * Biblioteca que contm as funes que manipulam datas e horas.
 *
 *
 * Depende
 * 	BibliotecaFuncoesPrincipal.js
  * 	BibliotecaMensagens.js
 */
 
// Verifica se o valor de pInput contm uma hora vlida
function isCampoHoraValido(pInput, pInObrigatorio, pExibirMensagem) {
	var mensagem = "";
	var vlCampo = pInput.value;
	var filtro = /^[0-9]{2}:[0-9]{2}$/;
	var hrs;
	var min;
	var isHoraValida = true;

	if ( pInObrigatorio != null || (typeof pInObrigatorio) == "undefined" ) {

		if ( pInObrigatorio ) {

			mensagem = "\n" + mensagemSistema(0);

		} else {

			mensagem = "\n" + mensagemSistema(1);

			if ( vlCampo == "" )
				return true;
		}
	}	
	
	if ( !filtro.test(vlCampo) ) {

		pInput.select();
		
		if ( pExibirMensagem ) {
			
			exibirMensagem(mensagemSistema(80) + mensagem);
		}
		
		focarCampo(pInput);

		return false;
	}

	hrs = (vlCampo.substring(0, 2));
	min = (vlCampo.substring(3, 5));

	if ( min.length == 0 ) {
	
		isHoraValida = false;
	}

	// verifica hora e minuto
	if ( (hrs < 00) || (hrs > 23) || (min < 00) || (min > 59) ) {

		isHoraValida = false;
	}

	if ( trim(pInput.value) == "" ) {
		
		isHoraValida = false;
	}

	if ( !isHoraValida ) {

		pInput.select();
		
		if ( pExibirMensagem ) {
			
			exibirMensagem(mensagemSistema(80) + mensagem);
		}
		
		focarCampo(pInput);

		return false;
	}

	return true;
}
 
// Formato o pInput com o valor de hora passado como parmetro na mascara hh:mm
function formatarCampoHora(pInput, pEvento) {
	var vlCampo = pInput.value;
	var tam = vlCampo.length;
	var filtro = /^([0-9:])*$/;

	if ( isTeclaFuncional(pEvento) ) {
		
		return;
	}

	if ( pEvento.keyCode == 191 ) {
		
		if ( vlCampo.length != 3 ) {
			
			pInput.value = vlCampo.substr(0, tam - 1);
		}
		
		return;
	}
		
	if ( !filtro.test(vlCampo) ) {

		pInput.value = vlCampo.substr(0, tam - 1);
		pInput.select();
		exibirMensagem(mensagemSistema(80));
		focarCampo(pInput);
		return;
	}

	if ( vlCampo.length == 2 && vlCampo.charAt(2) != ':' ) {
		
		vlCampo = vlCampo + ':';
		pInput.value = vlCampo;
	}
	
	if ( vlCampo.length > 2 && vlCampo.charAt(2) != ':' ) {
		
		vlCampo = vlCampo.substring(0, 2) + ':' + vlCampo.substring(2);
		pInput.value = vlCampo;
	}

	if ( vlCampo.length == 5 ) {
		isCampoHoraValido(pInput, null);
	}
}


// formata o campo pInput para o formato dd/mm/aaa ou mm/aaaa
function formatarCampoData(pInput, pEvento, pInMesAno) {
	var vlCampo = pInput.value;
	var tamanho = vlCampo.length;
	var filtro = /^([0-9\/])*$/;
	
	if ( isTeclaFuncional(pEvento) ) {
		return;
	}
	
	if ( pEvento.keyCode == 111 ) {
		
		if ( vlCampo.length != 3 && vlCampo.length != 6 ) {
			
			pInput.value = vlCampo.substr(0, tamanho - 1);
		}
		
		return;
	}

	if ( !filtro.test(vlCampo) ) {

		pInput.value = vlCampo.substr(0, tamanho - 1);
		pInput.select();
		exibirMensagem(mensagemSistema(81));
		focarCampo(pInput);
		return;
	}

	if ( vlCampo.length == 2 && vlCampo.charAt(2) != '/' ) {
		
		vlCampo = vlCampo + '/';
		pInput.value = vlCampo;
	}
	
	if ( vlCampo.length > 2 && vlCampo.charAt(2) != '/' ) {
		
		vlCampo = vlCampo.substring(0, 2) + '/' + vlCampo.substring(2);
		pInput.value = vlCampo;
	}

	if ( vlCampo.length == 5 ) {
		if ( pInMesAno ) {
		
			if ( vlCampo.substr(3, 4) <= 12 ) {

				vlCampo = vlCampo + '/';
				pInput.value = vlCampo;
			}
		} else {
		
			vlCampo = vlCampo + '/';
			pInput.value = vlCampo;
		}
	}
	
	if ( vlCampo.length > 5 && vlCampo.charAt(5) != '/' ) {

		vlCampo = vlCampo.substring(0, 5) + '/' + vlCampo.substring(5);
		pInput.value = vlCampo;
	}

	if ( vlCampo.length > 6 && vlCampo.charAt(6) == '0' ) {

		pInput.select();
		exibirMensagem(mensagemSistema(81) + '\n' + mensagemSistema(82));
		focarCampo(pInput);
		return;
	} else if ( vlCampo.length > 7 && parseInt(vlCampo.substring(6, 8)) < 19 ) {

		pInput.select();
		exibirMensagem(mensagemSistema(81) + '\n' + mensagemSistema(82));
		focarCampo(pInput);
		return;
	}

	if ( pInMesAno && vlCampo.length >= 7 ) {
		
		if ( vlCampo.substr(3, 4) > 12 ) {
			
			isCampoDataValido(pInput, null);
		}
	}

	if ( vlCampo.length == 10 ) {

		isCampoDataValido(pInput, null);
	}
}


function formatarCampoDataMesAno(pInput, pEvento, pInMesAno) {
	var vlCampo = pInput.value;
	var tamanho = vlCampo.length;
	var filtro = /^([0-9\/])*$/;
	
	if ( isTeclaFuncional(pEvento) ) {
		return;
	}
	
	if ( pEvento.keyCode == 111 ) {
		
		if ( vlCampo.length != 3 && vlCampo.length != 6 ) {
			
			pInput.value = vlCampo.substr(0, tamanho - 1);
		}
		
		return;
	}

	if ( !filtro.test(vlCampo) ) {

		pInput.value = vlCampo.substr(0, tamanho - 1);
		pInput.select();
		exibirMensagem(mensagemSistema(81));
		focarCampo(pInput);
		return;
	}

	if ( vlCampo.length == 2 && vlCampo.charAt(2) != '/' ) {
		
		vlCampo = vlCampo + '/';
		pInput.value = vlCampo;
	}
	
	/*
	if ( vlCampo.length > 2 && vlCampo.charAt(2) != '/' ) {
		
		vlCampo = vlCampo.substring(0, 2) + '/' + vlCampo.substring(2);
		pInput.value = vlCampo;
	}

	if ( vlCampo.length == 3 ) {
		if ( pInMesAno ) {
		
			if ( vlCampo.substr(3, 4) <= 12 ) {

				vlCampo = vlCampo + '/';
				pInput.value = vlCampo;
			}
		} else {
		
			vlCampo = vlCampo + '/';
			pInput.value = vlCampo;
		}
	}
	/*
	if ( vlCampo.length > 5 && vlCampo.charAt(5) != '/' ) {

		vlCampo = vlCampo.substring(0, 5) + '/' + vlCampo.substring(5);
		pInput.value = vlCampo;
	} */

	if ( vlCampo.length > 6 && vlCampo.charAt(6) == '0' ) {

		pInput.select();
		exibirMensagem(mensagemSistema(81) + '\n' + mensagemSistema(82));
		focarCampo(pInput);
		return;
	} else if ( vlCampo.length > 7 && parseInt(vlCampo.substring(6, 8)) < 19 ) {

		pInput.select();
		exibirMensagem(mensagemSistema(81) + '\n' + mensagemSistema(82));
		focarCampo(pInput);
		return;
	}

	if ( pInMesAno && vlCampo.length > 7 ) {
		
		if ( vlCampo.substr(3, 4) > 12 ) {
			
			isCampoDataValido(pInput, null);
		}
	}

	if ( vlCampo.length == 10 ) {

		isCampoDataValido(pInput, null);
	}
}









// Verifica se existe uma data vlida no campo "pInput" passado como parametro
function isCampoDataValido(pInput, pInObrigatorio, pInMesAno, pExibirMensagem) {
	var mensagem = "";
	var vlCampo = pInput.value;
	var filtro = '';
	var situacao = true;
	
	if ( pInObrigatorio != null || (typeof pInObrigatorio) == "undefined" ) {
		
		if (pInObrigatorio) {
			mensagem = "\n" + mensagemSistema(0);

		} else {
			mensagem = "\n" + mensagemSistema(1);

			if ( vlCampo == "" )
				return true;
		}
	}

	if ( pInMesAno && vlCampo.length == 7 ) {
		filtro = /^[0-9]{2}\/[0-9]{4}$/;
		
		if ( !filtro.test(vlCampo) ) {

			pInput.select();
			focarCampo(pInput);

			if ( pExibirMensagem ) {
				exibirMensagem(mensagemSistema(81) + mensagem);
			}
	
			return false;
		}
	
		dia = 01;
		mes = (vlCampo.substring(0, 2));
		ano = (vlCampo.substring(3, 7));

	} else {
		
		filtro = /^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$/;
		if ( !filtro.test(vlCampo) ) {

			pInput.select();
			
			if ( pExibirMensagem ) {
				exibirMensagem(mensagemSistema(81) + mensagem);
			}
			
			focarCampo(pInput);
						
			return false;
		}
	
		dia = (vlCampo.substring(0, 2));
		mes = (vlCampo.substring(3, 5));
		ano = (vlCampo.substring(6, 10));
	}
	
	//exibirMensagem('dia '+dia);
	//exibirMensagem('mes '+mes);
	//exibirMensagem('ano '+ano);


	// verifica o dia valido para cada mes 
	if ( (dia < 1) || (dia < 1 || dia > 30) && (mes == 4 || mes == 6 || mes == 9 || mes == 11) || dia > 31 ) {
		situacao = false;
	}

	// verifica se o mes e valido 
	if ( mes < 1 || mes > 12 ) {
		situacao = false;
	}

	// verifica se ano tem quatro caracteres
	if ( ano < 1900 ) {
		situacao = false;
	}

	// verifica se e ano bissexto 
	if ( mes == 2 && (dia < 1 || dia > 29 || (dia > 28 && (parseInt(ano / 4) != ano / 4))) ) {
		situacao = false;
	}

	if ( pInput.value == "" ) {
		situacao = false;
	}

	if ( situacao == false ) {
		
		pInput.select();
		
		if ( pExibirMensagem ) {
			exibirMensagem(mensagemSistema(81) + mensagem);
		}
		
		focarCampo(pInput);
		
		return false;
	}

	return true;
}

// retorna um Objeto Date com a data atual
function getDataHoje() {
	dataAtual = new Date();
	return new Date(dataAtual.getFullYear(), dataAtual.getMonth(), dataAtual.getDate());
}

// compara dois objetos do tipo Date e verifica se o primeiro eh menor, igual ou maior do que o segundo.
function compararDatas(pDataReferencia, pDataComparacao) {
		
		try {

			dia = pDataReferencia.getDate();
			dateReferencia = pDataReferencia;			

		} catch(e) {		

			var dtReferencia = trim(pDataReferencia);
		
			dia = (dtReferencia.substring(0, 2));
			mes = parseInt((dtReferencia.substring(3, 5)), 10) - 1;
			ano = (dtReferencia.substring(6, 10));
			dateReferencia = new Date(ano, mes, dia);
		}
		
		try {
			
			dia = pDataComparacao.getDate();
			dateComparacao = pDataComparacao;
		
		} catch(e) {					

			var dtComparacao = trim(pDataComparacao);		
				
			dia = (dtComparacao.substring(0, 2));
			mes = parseInt((dtComparacao.substring(3, 5)), 10) - 1;
			ano = (dtComparacao.substring(6, 10));
			dateComparacao = new Date(ano, mes, dia);
		}
				
		if (dateReferencia > dateComparacao) {			
			return CD_MAIOR;			
		} else if (dateReferencia < dateComparacao) {			
			return CD_MENOR;			
		} else {
			return CD_IGUAL;			
		}	

}

// retorna um Objeto Date apartir de uma data(dd/mm/aaaa) em string
function getStringComoData(pStrData) {
	var strData = trim(pStrData);
	
	dia = (strData.substring(0, 2));
	mes = parseInt((strData.substring(3, 5)), 10) - 1;
	ano = (strData.substring(6, 10));
	data = new Date(ano, mes, dia);
	
	return data;
}

// retorna uma string com a data(dd/mm/aaaa) apartir de um Objeto Date
function getDataComoString(pData) {
	var vlRetorno;
	
	try {
		dia = pData.getDate();
		mes = pData.getMonth() + 1;
		ano = pData.getFullYear();
			
		if(dia < 10)
			dia = "0" + dia;
		
		if(mes < 10)
			mes = "0" + mes;				
		
		strData = dia + "/" + mes + "/" + ano;
		
		vlRetorno = strData;		
	} catch(e) {
		vlRetorno = "";	
	}
	
	return vlRetorno;
}

// compara dois objetos do tipo Date e verifica se o primeiro igual ou maior do que o segundo.
function isDataMaiorIgual(pDataReferencia, pDataComparacao) {
	var vlRetorno = false;
	var vlComparacao = compararDatas(pDataReferencia, pDataComparacao);

	if ( vlComparacao == CD_MAIOR || vlComparacao == CD_IGUAL )
		vlRetorno = true;
		
	return vlRetorno;
}

// compara dois objetos do tipo Date e verifica se o primeiro igual ou menor do que o segundo.
function isDataMenorIgual(pDataReferencia, pDataComparacao) {
	var vlRetorno = false;
	var vlComparacao = compararDatas(pDataReferencia, pDataComparacao);

	if ( vlComparacao == CD_MENOR || vlComparacao == CD_IGUAL )
			vlRetorno = true;
		
	return vlRetorno;
}

// verifica se o objeto date e maior ou igual que a data de hj
function isDataMaiorIgualDataHoje(pData) {
	var vlRetorno = false;
	var vlComparacao = compararDatas(pData, getDataHoje());

	if ( vlComparacao == CD_MAIOR || vlComparacao == CD_IGUAL )
			vlRetorno = true;
		
	return vlRetorno;
}

// verifica se o objeto date e menor ou igual que a data de hj
function isDataMenorIgualDataHoje(pData) {
	var vlRetorno = false;
	var vlComparacao = compararDatas(pData, getDataHoje());

	if ( vlComparacao == CD_MENOR || vlComparacao == CD_IGUAL )
			vlRetorno = true;
		
	return vlRetorno;
}

// verifica se o objeto date e maior que a data de hj
function isDataMaiorDataHoje(pData) {
	var vlRetorno = false;
	var vlComparacao = compararDatas(pData, getDataHoje());

	if ( vlComparacao == CD_MAIOR )
			vlRetorno = true;
		
	return vlRetorno;
}

// verifica se o objeto date e menor que a data de hj
function isDataMenorDataHoje(pData) {
	var vlRetorno = false;
	var vlComparacao = compararDatas(pData, getDataHoje());

	if ( vlComparacao == CD_MENOR )
			vlRetorno = true;
		
	return vlRetorno;
}

// verifica se o pCampoData eh maior q a data passada
function isCampoDataMaior(pCampoData, pDataComparacao, pIsObrigatorio, pExibirMensagem) {
	var vlRetorno = true;
	var vlComparacao;
	var vlCampo = trim(pCampoData.value);
	var data;
	var mensagem = '';
	
	if ( !isCampoDataValido(pCampoData, pIsObrigatorio, false, pExibirMensagem) )
		return false;
	
	data = getStringComoData(vlCampo);

	vlComparacao = compararDatas(data, pDataComparacao)
	
	if ( vlComparacao == CD_MENOR || vlComparacao == CD_IGUAL )
		vlRetorno = false;
	else 
		vlRetorno = true;
	
	if ( vlRetorno == false ) {
		
		focarCampo(pCampoData);
		pCampoData.select();
		
		if ( pExibirMensagem ) {
			
			if ( pIsObrigatorio ) {
				
				mensagem = '\n' + mensagemSistema(0);
			} else {
			
				mensagem = '\n' + mensagemSistema(1);
			}
		
			exibirMensagem(mensagemSistema(83).replace(CD_CAMPO_SUBSTITUICAO, getDataComoString(pDataComparacao)) + mensagem);
		}
	}
	
	return vlRetorno;
}

// verifica se o pCampoData eh menor q a data passada
function isCampoDataMenor(pCampoData, pDataComparacao, pIsObrigatorio, pExibirMensagem) {
	var vlRetorno = true;
	var vlComparacao;
	var vlCampo = trim(pCampoData.value);
	var data;
	var mensagem = '';
	
	if ( !isCampoDataValido(pCampoData, pIsObrigatorio, false, pExibirMensagem) )
		return false;
	
	data = getStringComoData(vlCampo);

	vlComparacao = compararDatas(data, pDataComparacao)
	
	if ( vlComparacao == CD_MAIOR || vlComparacao == CD_IGUAL )
		vlRetorno = false;
	else 
		vlRetorno = true;
	
	if ( vlRetorno == false ) {
		
		focarCampo(pCampoData);
		pCampoData.select();
		
		if ( pExibirMensagem ) {
			
			if ( pIsObrigatorio ) {
				
				mensagem = '\n' + mensagemSistema(0);
			} else {
			
				mensagem = '\n' + mensagemSistema(1);
			}
		
			exibirMensagem(mensagemSistema(84).replace(CD_CAMPO_SUBSTITUICAO, getDataComoString(pDataComparacao)) + mensagem);
		}
	}
	
	return vlRetorno;
}



// verifica se o pCampoData eh maior q a data passada
function isCampoDataMaiorIgual(pCampoData, pDataComparacao, pIsObrigatorio, pExibirMensagem) {
	var vlRetorno = true;
	var vlComparacao;
	var vlCampo = trim(pCampoData.value);
	var data;
	var mensagem = '';
	
	if ( !isCampoDataValido(pCampoData, pIsObrigatorio, false, pExibirMensagem) )
		return false;
	
	data = getStringComoData(vlCampo);

	vlComparacao = compararDatas(data, pDataComparacao)
	
	if ( vlComparacao == CD_MENOR )
		vlRetorno = false;
	else 
		vlRetorno = true;
	
	if ( vlRetorno == false ) {
		
		focarCampo(pCampoData);
		pCampoData.select();
		
		if ( pExibirMensagem ) {
			
			if ( pIsObrigatorio ) {
				
				mensagem = '\n' + mensagemSistema(0);
			} else {
			
				mensagem = '\n' + mensagemSistema(1);
			}
		
			exibirMensagem(mensagemSistema(85).replace(CD_CAMPO_SUBSTITUICAO, getDataComoString(pDataComparacao)) + mensagem);
		}
	}
	
	return vlRetorno;
}

// verifica se o pCampoData eh menor q a data passada
function isCampoDataMenorIgual(pCampoData, pDataComparacao, pIsObrigatorio, pExibirMensagem) {
	var vlRetorno = true;
	var vlComparacao;
	var vlCampo = trim(pCampoData.value);
	var data;
	var mensagem = '';
	
	if ( !isCampoDataValido(pCampoData, pIsObrigatorio, false, pExibirMensagem) )
		return false;
	
	data = getStringComoData(vlCampo);

	vlComparacao = compararDatas(data, pDataComparacao)
	
	if ( vlComparacao == CD_MAIOR )
		vlRetorno = false;
	else 
		vlRetorno = true;
	
	if ( vlRetorno == false ) {
		
		focarCampo(pCampoData);
		pCampoData.select();
		
		if ( pExibirMensagem ) {
			
			if ( pIsObrigatorio ) {
				
				mensagem = '\n' + mensagemSistema(0);
			} else {
			
				mensagem = '\n' + mensagemSistema(1);
			}
		
			exibirMensagem(mensagemSistema(86).replace(CD_CAMPO_SUBSTITUICAO, getDataComoString(pDataComparacao)) + mensagem);
		}
	}
	
	return vlRetorno;
}

// verifica se o pCampoData eh maior que a data de hoje
function isCampoDataMaiorDataHoje(pCampoData, pIsObrigatorio, pExibirMensagem) {
	return isCampoDataMaior(pCampoData, getDataHoje(), pIsObrigatorio, pExibirMensagem);
}

// verifica se o pCampoData eh menor que a data de hoje
function isCampoDataMenorDataHoje(pCampoData, pIsObrigatorio, pExibirMensagem) {
	return isCampoDataMenor(pCampoData, getDataHoje(), pIsObrigatorio, pExibirMensagem);
}

// verifica se o pCampoData eh maior ou igual que a data de hoje
function isCampoDataMaiorIgualDataHoje(pCampoData, pIsObrigatorio, pExibirMensagem) {
	return isCampoDataMaiorIgual(pCampoData, getDataHoje(), pIsObrigatorio, pExibirMensagem);
}

// verifica se o pCampoData eh menor ou igual que a data de hoje
function isCampoDataMenorIgualDataHoje(pCampoData, pIsObrigatorio, pExibirMensagem) {
	return isCampoDataMenorIgual(pCampoData, getDataHoje(), pIsObrigatorio, pExibirMensagem);
}