/*
 * Biblioteca que contm as funes que manipulam datas e horas.
 *
 *
 * Depende
 * 	BibliotecaFuncoesPrincipal.js
  * 	BibliotecaMensagens.js
 */
 
function validarCampoDecimal(pInput, pQtCasasDecimais, pEvento) {

	var str = pInput.value;
	var menos = "";
	var inTemCaracterInvalido = false;
	
	if (isTeclaFuncional(pEvento)) {
		return;
	}

	for (loop = 0; loop < str.length;) {
		if ((str.charAt(loop) < '0' || str.charAt(loop) > '9') && str.charAt(loop) != '-' && str.charAt(loop) != ',') {
			str = str.substring(0, loop) + str.substring(loop + 1);
			inTemCaracterInvalido = true;
		} else {
			loop++;
		}
	}
	while (str.indexOf(',') > 0 && str.indexOf(',') < str.length - pQtCasasDecimais - 1) {
		str = str.substring(0, str.length - 1);
		inTemCaracterInvalido = true;
	}
	while (str.indexOf('-') > 0 || str.indexOf('-') != str.lastIndexOf('-')) {
		str = str.substring(0, str.lastIndexOf('-')) + str.substring(str.lastIndexOf('-') + 1);
		inTemCaracterInvalido = true;
	}

	if (inTemCaracterInvalido) {
		pInput.value = str;
	}
	
	return true;
}

// Verifica se o valor de pInput contm um decimal vlido
function isCampoDecimalValido(pInput, pQtCasasDecimais, pInObrigatorio, pVlMinimo, pVlMaximo) {
	
	var str = pInput.value;
	str = str.replace(",", ".");
	var tam = str.length;
	var floatAux = parseFloat(str);
	
	if (pInObrigatorio) {	
		var expReg = "^(-{0,1})([0-9]*)(\.{1}([0-9]{0," + pQtCasasDecimais + "})?)$";
		var filtro = new RegExp(expReg);
		var msg = "\n" + mensagemSistema(0);
	} else {
		var expReg = "^((-{0,1})([0-9]*)(\.{1}([0-9]{0," + pQtCasasDecimais + "})?))?$";
		var filtro = new RegExp(expReg);
		var msg = "\n" + mensagemSistema(1);
	}
		
	if (!filtro.test(str)) {
		pInput.select();
		exibirMensagem(mensagemSistema(121) + msg);
		pInput.focus();
		return false;
	}
	
	if (!isNaN(floatAux) && pVlMaximo != null && floatAux > pVlMaximo) {
		pInput.select();
		exibirMensagem((mensagemSistema(21) + msg).replace(CD_CAMPO_SUBSTITUICAO, pVlMaximo));
		pInput.focus();
		return false;
	}

	if (!isNaN(floatAux) && pVlMinimo != null && floatAux < pVlMinimo) {
		pInput.select();
		exibirMensagem((mensagemSistema(22) + msg).replace(CD_CAMPO_SUBSTITUICAO, pVlMinimo));
		pInput.focus();
		return false;
	}

	return true;

}

// Pega o valor decimal do pInput
function getValorCampoDecimal(pInput){
	var str = pInput.value;
	
	str = str.replace(",", ".");
	
	return str;
}

// Pega o valor decimal do pInput
function getValorApresentacao(pInput){
	var str = pInput.value;
	
	str = str.replace(".", ",");
	
	array = str.split(',');
	if (array.length > 1 && array[1].length == 1) {
		str = str + '0';
	} else if (array.length > 1 && array[1].length == 0) {
		str = str + '00';
	} else {
		str = str + ',00';
	}
	return str;
}

// Pega o valor decimal do pInput como float
function getValorCampoDecimalComoFloat(pInput) {
	var str = pInput.value;
	
	str = str.replace(",", ".");
	
	return parseFloat(str);
}
