/*
 * Biblioteca que contm as funes para validar input de HTML quando o tipo do mesmo for text.
 *
 * Depende
 * 	BibliotecaFuncoesPrincipal.js
  * 	BibliotecaMensagens.js
 */
 
 
 /*
 	Valida os campos numericos
 */
 
// Verifica se existe um valor numrico vlido no campo "pInput" passado como parametro
function isCampoNumericoValido(pInput, pIsObrigatorio, pVlMinimo, pVlMaximo, pTamanho, pExibirMensagem) {
	pInput.value = trim(pInput.value);
	var vlCampo = pInput.value; // str
	var vlCampoAux = parseInt(vlCampo, 10); // intAux
	var mensagem;
	var filtro;
	
	if ( pIsObrigatorio ) {
		
		filtro = /^-{0,1}([0-9])+$/;
		mensagem = "\n" + mensagemSistema(0);
	} else {
		
		filtro = /^-{0,1}([0-9])*$/;
		mensagem = "\n" + mensagemSistema(1);
	}
	
	if ( vlCampo != "" && isNaN(vlCampoAux)) {
		
		if ( pInput.type != "select-one" ) {
			pInput.select();
		}
		
		if ( pExibirMensagem ) {
			exibirMensagem(mensagemSistema(20) + mensagem);
		}
		
		focarCampo(pInput);

		return false;
	}
	
	if ( !filtro.test(vlCampo) ) {

		pInput.select();
		
		if( pExibirMensagem ) {
		
			if ( vlCampo == "" ) {
				exibirMensagem(mensagemSistema(2));
			} else {
				exibirMensagem(mensagemSistema(20) + mensagem);
			}
		}
		
		focarCampo(pInput);
		
		return false;
	}	
	
	if ( !isNaN(vlCampoAux) && pVlMaximo != null && vlCampoAux > pVlMaximo) {

		pInput.select();

		if( pExibirMensagem ) {
			exibirMensagem( (mensagemSistema(21) + mensagem).replace(CD_CAMPO_SUBSTITUICAO, pVlMaximo));
		}		

		focarCampo(pInput);
		return false;
	}
	
	if ( !isNaN(vlCampoAux) && pVlMinimo != null && vlCampoAux < pVlMinimo ) {

		pInput.select();

		if ( pExibirMensagem ) {
		
			exibirMensagem( (mensagemSistema(22) + mensagem).replace(CD_CAMPO_SUBSTITUICAO, pVlMinimo));
		}
		
		focarCampo(pInput);
		
		return false;
	}	
	
	if ( !isNaN(vlCampoAux) && pTamanho > 0 && vlCampo.length != pTamanho) {

		pInput.select();
		
		if( pExibirMensagem ){
			
			exibirMensagem((mensagemSistema(23) + mensagem).replace(CD_CAMPO_SUBSTITUICAO, pTamanho));
		}
		
		focarCampo(pInput);
		
		return false;
	}
	
	return true;
}

// utilizada para validar um campo texto valido "pInput" passado como parametro
function isCampoTextoValido(pInput, pInObrigatorio, pTmMinimo, pTmMaximo, pExibirMensagem) {
	var vlCampo = trim(pInput.value);
	var str = vlCampo;
	var mensagem;

	if (pInObrigatorio) {
	
		mensagem = "\n" + mensagemSistema(0);
	} else {
		
		mensagem = "\n" + mensagemSistema(1);
	}

	if ( pInObrigatorio && str == "" ) {

		pInput.select();
		
		if ( pExibirMensagem ) {				
			exibirMensagem(mensagemSistema(2));
		}
		
		focarCampo(pInput);
		return false;
	}
	
	if ( str != "" && pTmMinimo > 0 && str.length < pTmMinimo ) {

		pInput.select();
		
		if ( pExibirMensagem ){
			exibirMensagem((mensagemSistema(24) + mensagem).replace(CD_CAMPO_SUBSTITUICAO, pTmMinimo));
		}
		focarCampo(pinput);
		return false;
	}

	if ( str != "" && pTmMaximo > 0 && str.length > pTmMaximo ) {

		pInput.select();
		
		if ( pExibirMensagem ){			
			exibirMensagem((mensagemSistema(25) + mensagem).replace(CD_CAMPO_SUBSTITUICAO, pTmMaximo));
		}
		
		focarCampo(pInput);
		
		return false;
	}
	
	return true;
}

// Valida o preenchimento do campo numerico "pInput" passado como parametro
// Deve ser chamada no evento onkeyup do componente input text
function validarCampoNumerico(pInput, pEvento) {
	var str = pInput.value;
	var tam = str.length;

	if (isTeclaFuncional(pEvento)) {
		return;
	}

	var filtro = /^-{0,1}([0-9])*$/;

	if (!filtro.test(str)) {
		pInput.value = str.substr(0, tam - 1)
		pInput.select();
		exibirMensagem(mensagemSistema(20));
		focarCampo(pInput);
	}
}

// Valida o preenchimento do campo numerico negativo "pInput" passado como parametro
// Permite o valor zero
// Deve ser chamada no evento onkeyup do componente input text
function validarCampoNumericoNegativo(pInput, pEvento) {
	var str = pInput.value;
	var tam = str.length;
	var intAux = parseInt(str, 10);

	if (isTeclaFuncional(pEvento)) {
		return;
	}

	var filtro = /^-{0,1}([0-9])*$/;

	if (!filtro.test(str)) {
		pInput.value = str.substr(0, tam - 1)
		pInput.select();
		exibirMensagem(mensagemSistema(26));
		focarCampo(pInput);
	}
	
	if (intAux > 0) {
		pInput.value = str.substr(0, tam - 1)
		pInput.select();
		exibirMensagem(mensagemSistema(26));
		focarCampo(pInput);
	}
}

// Valida o preenchimento do campo numerico positivo "pInput" passado como parametro
// Permite o valor zero
// Deve ser chamada no evento onkeyup do componente input text
function validarCampoNumericoPositivo(pInput, pEvento) {
	var str = pInput.value;
	var tam = str.length;
	var intAux = parseInt(str, 10);

	if (isTeclaFuncional(pEvento)) {
		return;
	}

	var filtro = /^([0-9])*$/;

	if (!filtro.test(str)) {
		pInput.value = str.substr(0, tam - 1)
		pInput.select();
		exibirMensagem(mensagemSistema(27));
		focarCampo(pInput);
	}
}
