package com.efetiva.wiiser.server.business;

import com.efetiva.wiser.exception.NullObjectException;

public aspect BusinessAspect {
	
	pointcut businessExecution():
		execution(public * *Control.*(..)) &&
		!execution(public * *Control.*());
	
	before() throws NullObjectException:businessExecution(){
		Object[] objs = thisJoinPoint.getArgs();
		for(Object o:objs){
			if(o == null){				
				throw new NullObjectException("Objeto nulo passado no mtodo: "+thisJoinPoint.getSignature());
			}
		}
	}

}
