package com.efetiva.wiiser.server.business;

import java.util.ArrayList;
import java.util.Collection;

import com.efetiva.wiiser.server.entity.CategoryActivity;
import com.efetiva.wiiser.server.repository.CategoryActivityRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.ICategoryActivityControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryActivityRepository;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class CategoryActivityControl implements ICategoryActivityControl {

	private ICategoryActivityRepository categoryActivities;

	public CategoryActivityControl() {
		categoryActivities = new CategoryActivityRepository();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryActivityControl#register(com.efetiva.wiser.entity.CategoryActivity)
	 */
	public void register(CategoryActivity categoryActivity)
	throws ExistingObjectException, NullObjectException {		
		this.categoryActivities.register(categoryActivity);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryActivityControl#search(java.lang.Integer,
	 *      java.lang.Integer)
	 */
	public CategoryActivity search(Integer categoryID, Integer activityID)
	throws NullObjectException {
		CategoryActivity categoryActivity = this.categoryActivities.search(categoryID, activityID);		
		return categoryActivity;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryActivityControl#remove(com.efetiva.wiser.entity.CategoryActivity)
	 */
	public void remove(CategoryActivity categoryActivity)
	throws NonExistingObjectException, NullObjectException {		
		this.categoryActivities.remove(categoryActivity);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryActivityControl#searchAll()
	 */
	public Collection searchAll() {
		return this.categoryActivities.searchAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryActivityControl#searchByLanguage(java.lang.Integer)
	 */
	public Collection searchByLanguage(Integer languageID)
	throws NullObjectException {
		Collection categoriActivities = new ArrayList();		
		categoriActivities = this.categoryActivities
		.searchByLanguage(languageID);		
		return categoriActivities;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#searchForActivity(java.lang.Integer)
	 */
	public Collection searchByActivity(Integer activityID)
	throws NullObjectException {
		Collection categoriActivities = new ArrayList();		
		categoriActivities = this.categoryActivities
		.searchByActivity(activityID);		
		return categoriActivities;
	}

	public void removeByActivity(Integer activityID) throws NullObjectException {		
		this.categoryActivities.removeByActivity(activityID);		
	}

}
