package com.efetiva.wiiser.server.business;

import java.util.Collection;
import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.repository.CategoryRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.ICategoryControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryRepository;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class CategoryControl implements ICategoryControl {

	private ICategoryRepository categories;

	public CategoryControl() {
		categories = new CategoryRepository();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IcategoryControl#register(com.efetiva.wiser.entity.Category)
	 */
	public void register(Category category) throws ExistingObjectException,
	NullObjectException {		
		this.categories.register(category);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryControl#search(java.lang.Integer)
	 */
	public Category search(Integer ID) throws NullObjectException {
		Category category = this.categories.search(ID);		
		return category;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryControl#modify(com.efetiva.wiser.entity.Category)
	 */
	public void modify(Category category) throws NonExistingObjectException,
	NullObjectException {		
		this.categories.modify(category);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryControl#remove(com.efetiva.wiser.entity.Category)
	 */
	public void remove(Category category) throws NonExistingObjectException,
	NullObjectException {		
		this.categories.remove(category);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryControl#searchAll()
	 */
	public Collection searchAll() {
		return this.categories.searchAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryControl#searchByLanguage(java.lang.Integer)
	 */
	public Collection searchByLanguage(Integer languageID) throws NullObjectException{
		return this.categories.searchByLanguage(languageID);
	}
}
