package com.efetiva.wiiser.server.business;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.CategoryPlace;
import com.efetiva.wiiser.server.repository.CategoryPlaceRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.ICategoryPlaceControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryPlaceRepository;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class CategoryPlaceControl implements ICategoryPlaceControl {

	private ICategoryPlaceRepository categoryPlaces;

	public CategoryPlaceControl() {
		categoryPlaces = new CategoryPlaceRepository();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryPlaceControl#register(com.efetiva.wiser.entity.CategoryPlace)
	 */
	public void register(CategoryPlace categoryPlace)
	throws NonExistingObjectException, NullObjectException {		
		this.categoryPlaces.register(categoryPlace);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryPlaceControl#search(java.lang.Integer,
	 *      java.lang.Integer)
	 */
	public CategoryPlace search(Integer categoryID, Integer placeID)
	throws NullObjectException {
		CategoryPlace categoryPlace = this.categoryPlaces.search(categoryID, placeID);		
		return categoryPlace;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryPlaceControl#remove(com.efetiva.wiser.entity.CategoryPlace)
	 */
	public void remove(CategoryPlace categoryPlace)
	throws NonExistingObjectException, NullObjectException {		
		this.categoryPlaces.remove(categoryPlace);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryPlaceControl#searchAll()
	 */
	public Collection searchAll() {
		return this.categoryPlaces.searchAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryPlaceControl#searchByPlace(java.lang.Integer)
	 */
	public Collection searchByPlace(Integer placeID) throws NullObjectException {		
		return this.categoryPlaces.searchByPlace(placeID);		
	}

	public void removeByPlace(Integer placeID) throws NullObjectException {		
		this.categoryPlaces.removeByPlace(placeID);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryPlaceControl#searchByLanguage(java.lang.Integer)
	 */
	public Collection searchByLanguage(Integer languageID)
	throws NullObjectException {			
		return this.categoryPlaces.searchByLanguage(languageID);		
	}

}
