package com.efetiva.wiiser.server.business;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.CategoryService;
import com.efetiva.wiiser.server.repository.CategoryServiceRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.ICategoryServiceControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryServiceRepository;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class CategoryServiceControl implements ICategoryServiceControl {

	private ICategoryServiceRepository categoryServices;

	public CategoryServiceControl() {
		categoryServices = new CategoryServiceRepository();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryServiceControl#register(com.efetiva.wiser.entity.CategoryService)
	 */
	public void register(CategoryService categoryService)
	throws ExistingObjectException, NullObjectException {		
		this.categoryServices.register(categoryService);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryServiceControl#search(java.lang.Integer,
	 *      java.lang.Integer)
	 */
	public CategoryService search(Integer categoryID, Integer ID_Service)
	throws NullObjectException {
		CategoryService categoryService = this.categoryServices.search(categoryID, ID_Service);		
		return categoryService;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryServiceControl#remove(com.efetiva.wiser.entity.CategoryService)
	 */
	public void remove(CategoryService categoryService)
	throws NonExistingObjectException, NullObjectException {		
		this.categoryServices.remove(categoryService);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryServiceControl#searchAll()
	 */
	public Collection searchAll() {
		return this.categoryServices.searchAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ICategoryServiceControl#searchForService(java.lang.Integer)
	 */
	public Collection searchByService(Integer ID_Service) throws NullObjectException{
		return this.categoryServices.searchByService(ID_Service);
	}

	public void removeByService(Integer serviceID) throws NullObjectException{
		this.categoryServices.removeByService(serviceID);
	}

}