package com.efetiva.wiiser.server.business;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.repository.LanguageRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.ILanguageControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.ILanguageRepository;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class LanguageControl implements ILanguageControl{

	private ILanguageRepository languages;

	/**
	 * 
	 */
	public LanguageControl() {
		languages = new LanguageRepository();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ILanguageControl#modify(com.efetiva.wiser.entity.Language)
	 */
	public void modify(Language language) throws NonExistingObjectException, NullObjectException {		
		this.languages.modify(language);			
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ILanguageControl#register(com.efetiva.wiser.entity.Language)
	 */
	public void register(Language language) throws ExistingObjectException, NullObjectException {		
		this.languages.register(language);			
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ILanguageControl#remove(com.efetiva.wiser.entity.Language)
	 */
	public void remove(Language language) throws NonExistingObjectException, NullObjectException {
		this.languages.remove(language);			
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ILanguageControl#search(java.lang.Integer)
	 */
	public Language search(Integer ID) throws NullObjectException {
		Language languageFound = this.languages.search(ID);		
		return languageFound;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.ILanguageControl#searchAll()
	 */
	public Collection searchAll() {
		return this.languages.searchAll();
	}

	public Language searchByName(String name) throws NullObjectException {
		Language languageFound = this.languages.searchByName(name);		
		return languageFound;
	}


}
