package com.efetiva.wiiser.server.business;

import com.efetiva.wiiser.server.entity.Map;
import com.efetiva.wiiser.server.repository.MapRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.IMapControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.IMapRepository;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;


public class MapControl implements IMapControl {

	private IMapRepository map;

	/***************************************************************************
	 * Constructor of MapControl
	 * 
	 */
	public MapControl() {
		this.map = new MapRepository();
	}

	/***************************************************************************
	 * Stores a Map object in the DB
	 * 
	 * @param map
	 *            map to be stored
	 * @throws ExistingObjectException
	 */
	public void register(Map map) throws ExistingObjectException,NullObjectException {		
		this.map.register(map);

	}

	/***************************************************************************
	 * Returns a Map object searched by its identification in the DB.
	 * <p>
	 * If the Map isn't found it returns null.
	 * 
	 * @param ID
	 *            the identification in the DB
	 * @return a Map object
	 */
	public Map search(Integer ID) throws NullObjectException{
		Map map = this.map.search(ID);		
		return map;
	}

	/***************************************************************************
	 * Updates a Map object in the DB
	 * 
	 * @param map
	 *            map to be updated
	 * @throws NonExistingObjectException
	 */
	public void modify(Map map) throws NonExistingObjectException, NullObjectException {
		if (map.getId() != null) {
			this.map.modify(map);
		} else {
			throw new NonExistingObjectException("Map");// TODO
			// MapaInexistenteException
		}
	}

}
