package com.efetiva.wiiser.server.business;

import java.util.ArrayList;
import java.util.Collection;

import com.efetiva.wiiser.server.entity.PlaceArea;
import com.efetiva.wiiser.server.repository.PlaceAreaRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.IPlaceAreaControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.IPlaceAreaRepository;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class PlaceAreaControl implements IPlaceAreaControl {

	private IPlaceAreaRepository placesAreas;

	/**
	 * 
	 */
	public PlaceAreaControl() {
		this.placesAreas = new PlaceAreaRepository();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IPlaceAreaControl#register(wisser.server.entity.PlaceArea)
	 */
	public void register(PlaceArea placeArea) throws ExistingObjectException,
	NullObjectException {		
		this.placesAreas.register(placeArea);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IPlaceAreaControl#remove(wisser.server.entity.PlaceArea)
	 */
	public void remove(PlaceArea placeArea) throws NonExistingObjectException,
	NullObjectException {		
		this.placesAreas.remove(placeArea);		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IPlaceAreaControl#search(java.lang.Integer,
	 *      java.lang.Integer)
	 */
	public PlaceArea searchByPlaceArea(Integer placeID, Integer areaID)
	throws NullObjectException {
		PlaceArea placeArea = this.placesAreas.searchByPlaceArea(placeID, areaID);		
		return placeArea;
	}

	public void modify(PlaceArea placeArea) throws NonExistingObjectException,
	NullObjectException {		
		this.placesAreas.modify(placeArea);		
	}

	public PlaceArea search(Integer id) throws NullObjectException{
		PlaceArea placeArea = this.placesAreas.search(id);		
		return placeArea;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IPlaceAreaControl#searchAll(java.lang.Integer)
	 */
	public Collection searchAll() {
		return this.placesAreas.searchAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IPlaceAreaControl#searchByPlace(java.lang.Integer)
	 */
	public Collection searchByPlace(Integer placeID) throws NullObjectException {
		Collection placesAreas = new ArrayList();		
		placesAreas = this.placesAreas.searchByPlace(placeID);		
		return placesAreas;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.business.IPlaceAreaControl#searchByArea(java.lang.Integer)
	 */
	public Collection searchByArea(Integer areaID, Integer languageID)
	throws NullObjectException {
		Collection placesAreas = new ArrayList();		
		placesAreas = this.placesAreas.searchByArea(areaID, languageID);		
		return placesAreas;
	}

	public void removeByPlace(Integer placeID) throws NullObjectException{
		this.placesAreas.removeByPlace(placeID);
	}

}
