package com.efetiva.wiiser.server.business;

import java.util.ArrayList;
import java.util.Collection;

import com.efetiva.wiiser.server.entity.ScheduleService;
import com.efetiva.wiiser.server.repository.ScheduleServiceRepository;
import com.efetiva.wiiser.server.repository.interfaceBusiness.IScheduleServiceControl;
import com.efetiva.wiiser.server.repository.interfaceRepository.IScheduleServiceRepository;
import com.efetiva.wiser.exception.NullObjectException;

public class ScheduleServiceControl implements IScheduleServiceControl {

	private IScheduleServiceRepository scheduleServices;

	/***************************************************************************
	 * Constructor of ScheduleServiceControl
	 * 
	 */
	public ScheduleServiceControl() {
		this.scheduleServices = new ScheduleServiceRepository();
	}

	/***************************************************************************
	 * Stores a ScheduleService object in the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be stored
	 */
	public void register(ScheduleService schedule) throws NullObjectException{	
		this.scheduleServices.register(schedule);		
	}

	/***************************************************************************
	 * Removes a ScheduleService object from the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be removed
	 */
	public void remove(ScheduleService schedule) throws NullObjectException{		
		this.scheduleServices.remove(schedule);		
	}

	/***************************************************************************
	 * Removes a ScheduleService object from the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be removed
	 */
	public ScheduleService search(Integer id) throws NullObjectException{
		ScheduleService schedule = this.scheduleServices.search(id);		
		return schedule;
	}

	/***************************************************************************
	 * Updates a ScheduleService object in the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be updated
	 */
	public void modify(ScheduleService schedule) throws NullObjectException{		
		this.scheduleServices.modify(schedule);
	}

	/***************************************************************************
	 * Returns a collection of ScheduleService object searched by service
	 * identification in the DB.
	 * <p>
	 * If any ScheduleService isn't found it returns an empty collection.
	 * 
	 * @param ID
	 *            service identification in the DB
	 * @return a ScheduleService object
	 */
	public Collection searchByService(Integer ID) throws NullObjectException{
		Collection schedules = new ArrayList();		
		schedules = this.scheduleServices.searchByService(ID);		
		return schedules;
	}

	public Collection searchAll() {
		return this.scheduleServices.searchAll();
	}

	public void removeByService(Integer serviceID) throws NullObjectException{
		this.scheduleServices.removeByService(serviceID);
	}	

}
