/**
 * 
 */
package com.efetiva.wiiser.server.comm;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import org.hibernate.Session;


import com.efetiva.wiiser.server.entity.ScheduleInfo;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;
import com.efetiva.wiser.entity.model.DynamicInfoModel;
import communication.server.Server;

/**
 * @author rtn
 * 
 */
public class ServerThreadComm extends Thread {

	private Server server;

	private Facade facade;

	public ServerThreadComm(Server server) {
		this.facade = Facade.getInstance();
		this.server = server;
		this.start();
	}

	public void run() {
		Date d = null;
		Session currentSession = null;
		while (true) {
			try {
				d = Calendar.getInstance().getTime();
				currentSession = HibernateUtil.getCurrentSession();
				currentSession.beginTransaction();

				Collection infoModel = new ArrayList();
				Collection dynamicInfos = facade.searchScheduleInfoByHour(d);
				Iterator i = dynamicInfos.iterator();
				while (i.hasNext()) {
					ScheduleInfo schedule = (ScheduleInfo) i.next();
					DynamicInfoModel info = new DynamicInfoModel(schedule.getDynamicInfo()
							.getDescription(), schedule.getDynamicInfo()
							.getLanguage().getId(), schedule.getArea()
							.getName());
					System.out.println("DynamicInfo:" + info.getDescription());
					infoModel.add(info);
				}
				HibernateUtil.closeSession();
				if (!dynamicInfos.isEmpty()) {
					System.out.println("Dynamic Info entrou no if carai");
					server.sendDynamicInfos(infoModel);					
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
				e.printStackTrace();
			}

			try {
				Thread.sleep(60000);
			} catch (InterruptedException e) {
				System.out.println(e.getMessage());
			}
		}
	}

	public static void main(String[] args) {
		new ServerThreadComm(null);
	}
}
