package com.efetiva.wiiser.server.entity;

import java.io.Serializable;
import java.util.Collection;

public class Activity implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer id;

	private String name;

	private String description;

	private Double value;

	private String photo;

	private Place place;

	private Language language;

	private Integer isActive;
	
	private Collection schedules;

	public Activity() {

	}

	public Activity(String name, String description, Double value,
			String photo, Place place, Language language, Integer isActive) {
		this.name = name;
		this.description = description;
		this.value = value;
		this.photo = photo;
		this.place = place;
		this.language = language;
		this.isActive = isActive;
	}
	
	public Activity(Integer id, String name, String description, Double value,
			String photo, Place place, Language language, Integer isActive) {
		this.id = id;
		this.name = name;
		this.description = description;
		this.value = value;
		this.photo = photo;
		this.place = place;
		this.language = language;
		this.isActive = isActive;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getIsActive() {
		return isActive;
	}

	public void setIsActive(Integer isActive) {
		this.isActive = isActive;
	}

	public Language getLanguage() {
		return language;
	}

	public void setLanguage(Language language) {
		this.language = language;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPhoto() {
		return photo;
	}

	public void setPhoto(String photo) {
		this.photo = photo;
	}


	public Place getPlace() {
		return place;
	}

	public void setPlace(Place place) {
		this.place = place;
	}

	public Collection getSchedules() {
		return schedules;
	}

	public void setSchedules(Collection schedules) {
		this.schedules = schedules;
	}

	public Double getValue() {
		return value;
	}

	public void setValue(Double value) {
		this.value = value;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Activity other = (Activity) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

}
