package com.efetiva.wiiser.server.entity;

import java.io.Serializable;

public class Area implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer id;

	private String name;

	private String description;

	private String photo;

	private Map map;

	private Integer coordX;

	private Integer coordY;

	private Language language;

	public Area() {

	}

	public Area(String name, String description, String photo,
			Map map, Integer coordX, Integer coordY, Language language) {
		this.name = name;
		this.description = description;
		this.photo = photo;
		this.map = map;
		this.coordX = coordX;
		this.coordY = coordY;
		this.language = language;
	}
	
	public Area(Integer id, String name, String description, String photo,
			Map map, Integer coordX, Integer coordY, Language language) {
		this.id = id;
		this.name = name;
		this.description = description;
		this.photo = photo;
		this.map = map;
		this.coordX = coordX;
		this.coordY = coordY;
		this.language = language;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Map getMap() {
		return map;
	}

	public void setMap(Map map) {
		this.map = map;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Area other = (Area) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

	/**
	 * @return the photo
	 */
	public String getPhoto() {
		return photo;
	}

	/**
	 * @param photo
	 *            the photo to set
	 */
	public void setPhoto(String photo) {
		this.photo = photo;
	}

	/**
	 * @return the coordX
	 */
	public Integer getCoordX() {
		return coordX;
	}

	/**
	 * @param coordX
	 *            the coordX to set
	 */
	public void setCoordX(Integer coordX) {
		this.coordX = coordX;
	}

	/**
	 * @return the coordY
	 */
	public Integer getCoordY() {
		return coordY;
	}

	/**
	 * @param coordY
	 *            the coordY to set
	 */
	public void setCoordY(Integer coordY) {
		this.coordY = coordY;
	}

	/**
	 * @return the language
	 */
	public Language getLanguage() {
		return language;
	}

	/**
	 * @param language
	 *            the language to set
	 */
	public void setLanguage(Language language) {
		this.language = language;
	}

}
