package com.efetiva.wiiser.server.entity;

import java.io.Serializable;

public class DynamicInfo implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer id;

	private String description;

	private Area area;

	private Language language;

	public DynamicInfo() {

	}

	public DynamicInfo(Integer id, String description, Language language) {
		this.id = id;
		this.description = description;
		this.language = language;
	}
	
	public DynamicInfo(Integer id, String description, Language language, Area area) {
		this.id = id;
		this.description = description;
		this.language = language;
		this.area = area;
	}
	
	public DynamicInfo(String description, Language language) {
		this.description = description;
		this.language = language;
	}

	public Area getArea() {
		return area;
	}

	public void setArea(Area area) {
		this.area = area;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Language getLanguage() {
		return language;
	}

	public void setLanguage(Language language) {
		this.language = language;
	}

	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final DynamicInfo other = (DynamicInfo) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

}
