package com.efetiva.wiiser.server.entity;

import java.io.Serializable;

public class Place implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer id;

	private String name;

	private String description;

	private String photo;

	private Language language;

	private byte[] photoImage;

	/**
	 * 
	 *
	 */
	public Place() {

	}
	
	/**
	 * 
	 * @param id
	 * @param name
	 * @param description
	 * @param photo
	 * @param language
	 */
	public Place(Integer id, String name, String description, String photo,
			Language language) {
		this.id = id;
		this.name = name;
		this.description = description;
		this.photo = photo;
		this.language = language;
	}
	
	/**
	 * 
	 * @param name
	 * @param description
	 * @param photo
	 * @param language
	 */
	public Place(String name, String description, String photo,
			Language language) {
		this.name = name;
		this.description = description;
		this.photo = photo;
		this.language = language;
	}

	public String getDescription() {
		return description;
	}
	
	public void setDescription(String description) {
		this.description = description;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPhoto() {
		return photo;
	}

	public void setPhoto(String photo) {
		this.photo = photo;
	}

	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Place other = (Place) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

	/**
	 * @return the photoImage
	 */
	public byte[] getPhotoImage() {
		return photoImage;
	}

	/**
	 * @param photoImage
	 *            the photoImage to set
	 */
	public void setPhotoImage(byte[] photoImage) {
		this.photoImage = photoImage;
	}

	/**
	 * @return the language
	 */
	public Language getLanguage() {
		return language;
	}

	/**
	 * @param language
	 *            the language to set
	 */
	public void setLanguage(Language language) {
		this.language = language;
	}

}
