package com.efetiva.wiiser.server.entity;

import java.io.Serializable;

public class User implements Serializable {

	private static final long serialVersionUID = 1L;

	public static final String ADMINISTRATOR = "Administrador";

	public static final String MANAGER = "Funcionrio";

	private String username;

	private String password;

	private String permission;

	/***
	 * Constructor of User
	 *
	 */
	public User() {

	}

	/***
	 * Gets the password
	 * 
	 * @return	the password
	 */
	public String getPassword() {
		return password;
	}

	/***
	 * Sets the password
	 * 
	 * @param password	new password
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/***
	 * Gets the permission
	 * @return	the permission
	 */
	public String getPermission() {
		return permission;
	}

	/***
	 * Sets the permission
	 * @param permission	new permission
	 */
	public void setPermission(String permission) {
		this.permission = permission;
	}

	/***
	 * Gets the username
	 * @return the username
	 */
	public String getUsername() {
		return username;
	}

	/***
	 * Sets the username
	 * @param username	new username
	 */
	public void setUsername(String username) {
		this.username = username;
	}

	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result
				+ ((username == null) ? 0 : username.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final User other = (User) obj;
		if (username == null) {
			if (other.username != null)
				return false;
		} else if (!username.equals(other.username))
			return false;
		return true;
	}

}
