package com.efetiva.wiiser.server.repository;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.hibernate.Query;
import org.hibernate.Session;

import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.CategoryActivity;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryActivityRepository;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public class CategoryActivityRepository implements ICategoryActivityRepository {

	/***************************************************************************
	 * Constructor of categoryActivityRepository
	 * 
	 */
	public CategoryActivityRepository() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#register(com.efetiva.wiser.entity.CategoryActivity)
	 */
	public void register(CategoryActivity categoryActivity) {
		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.save(categoryActivity);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#search(java.lang.Integer)
	 */
	public CategoryActivity search(Integer categoryID, Integer activityID) {
		String query = "select categoryActivity.activity, categoryActivity.category "
				+ "from CategoryActivity as categoryActivity where categoryActivity.activity.id = "
				+ activityID
				+ " and categoryActivity.category.id = "
				+ categoryID;
		CategoryActivity categoryActivity = null;

		categoryActivity = queryCategoryActivitiy(query, categoryActivity);
		
		return categoryActivity;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#remove(com.efetiva.wiser.entity.CategoryActivity)
	 */
	public void remove(CategoryActivity categoryActivity) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.delete(categoryActivity);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#searchAll()
	 */
	public Collection searchAll() {
		String query = "select categoryActivity.activity, categoryActivity.category "
				+ "from CategoryActivity as categoryActivity";
		Collection all = new ArrayList();

		queryCategoryActivitiesCollection(query, all);

		return all;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#searchByLanguage(java.lang.Integer)
	 */
	public Collection searchByLanguage(Integer languageID) {
		String query = "select categoryActivity.activity, categoryActivity.category "
				+ "from CategoryActivity as categoryActivity "
				+ "where categoryActivity.activity.language.id = " + languageID;
		Collection all = new ArrayList();

		queryCategoryActivitiesCollection(query, all);

		return all;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryActivityRepository#searchForActivity(java.lang.Integer)
	 */
	public Collection searchByActivity(Integer activityID) {
		String query = "select categoryActivity.activity, categoryActivity.category "
				+ "from CategoryActivity as categoryActivity where categoryActivity.activity.id = "
				+ activityID;
		Collection all = new ArrayList();

		queryCategoryActivitiesCollection(query, all);

		return all;
	}

	public void removeByActivity(Integer activityID) {

		String query = "delete from CategoryActivity as categoryActivity where categoryActivity.activity.id = "
				+ activityID;
		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.createQuery(query);

	}
	
	/*
	 * metodos privados
	 * metodos extraidos
	 */
	
	private CategoryActivity queryCategoryActivitiy(String query,CategoryActivity categoryActivity) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			categoryActivity = new CategoryActivity((Activity) array[0],
					(Category) array[1]);
		}
		return categoryActivity;
	}
	
	private void queryCategoryActivitiesCollection(String query, Collection all) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			CategoryActivity categoryActivity = new CategoryActivity(
					(Activity) array[0], (Category) array[1]);
			all.add(categoryActivity);
		}
	}
	
}
