package com.efetiva.wiiser.server.repository;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.hibernate.Query;
import org.hibernate.Session;

import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.CategoryPlace;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryPlaceRepository;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public class CategoryPlaceRepository implements ICategoryPlaceRepository {

	/***************************************************************************
	 * Constructor of categoryPlaceRepository
	 * 
	 */
	public CategoryPlaceRepository() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryPlaceRepository#register(com.efetiva.wiser.entity.CategoryPlace)
	 */
	public void register(CategoryPlace categoryPlace) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.save(categoryPlace);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryPlaceRepository#search(java.lang.Integer)
	 */
	public CategoryPlace search(Integer categoryID, Integer placeID) {
		String query = "select categoryPlace.place, categoryPlace.category from "
				+ "CategoryPlace as categoryPlace where categoryPlace.place.id = "
				+ placeID + " and categoryPlace.category.id = " + categoryID;
		CategoryPlace categoryPlace = null;
		
		categoryPlace = queryCategoryPlace(query, categoryPlace);
		
		return categoryPlace;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryPlaceRepository#remove(com.efetiva.wiser.entity.CategoryPlace)
	 */
	public void remove(CategoryPlace categoryPlace) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.delete(categoryPlace);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryPlaceRepository#searchAll()
	 */
	public Collection searchAll() {
		String query = "select categoryPlace.place, categoryPlace.category from "
				+ "CategoryPlace as categoryPlace";
		Collection all = new ArrayList();

		queryCategoryPlacesCollection(query, all);
		
		return all;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryPlaceRepository#searchByLanguage(java.lang.Integer)
	 */
	public Collection searchByLanguage(Integer languageID) {
		String query = "select categoryPlace.place, categoryPlace.category from"
				+ " CategoryPlace as categoryPlace where"
				+ " categoryPlace.place.language.id = "
				+ languageID
				+ " and categoryPlace.category.language.id = " + languageID;
		Collection all = new ArrayList();

		queryCategoryPlacesCollection(query, all);
		
		return all;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryPlaceRepository#searchForPlace(java.lang.Integer)
	 */
	public Collection searchByPlace(Integer placeID) {
		String query = "select categoryPlace.place, categoryPlace.category from "
				+ "CategoryPlace as categoryPlace where categoryPlace.place.id = "
				+ placeID;
		Collection all = new ArrayList();

		queryCategoryPlacesCollection(query, all);

		return all;
	}

	public void removeByPlace(Integer placeID) {
		String query = "delete from CategoryPlace as categoryPlace where categoryPlace.place.id = "
				+ placeID;
		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.createQuery(query);
	}
	
	/*
	 * metodos privados
	 * metodos extraidos
	 */
	
	private CategoryPlace queryCategoryPlace(String query,
			CategoryPlace categoryPlace) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			categoryPlace = new CategoryPlace((Place) array[0],
					(Category) array[1]);
		}
		return categoryPlace;
	}
	
	private void queryCategoryPlacesCollection(String query, Collection all) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			CategoryPlace categoryPlace = new CategoryPlace((Place) array[0],
					(Category) array[1]);
			all.add(categoryPlace);
		}
	}

}
