package com.efetiva.wiiser.server.repository;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.hibernate.Query;
import org.hibernate.Session;

import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryRepository;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public class CategoryRepository implements ICategoryRepository {

	/***************************************************************************
	 * Constructor of CategoryRepository
	 * 
	 */
	public CategoryRepository() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryRepository#register(com.efetiva.wiser.entity.Category)
	 */
	public void register(Category category) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.save(category);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryRepository#search(java.lang.Integer)
	 */
	public Category search(Integer ID) {
		String query = "select category.id, category.name, category.language "
				+ "from Category as category where category.id = " + ID;
		Category category = null;

		category = queryCategory(query, category);

		return category;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryRepository#remove(com.efetiva.wiser.entity.Category)
	 */
	public void remove(Category category) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.delete(category);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryRepository#modify(com.efetiva.wiser.entity.Category)
	 */
	public void modify(Category category) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.update(category);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryRepository#searchAll()
	 */
	public Collection searchAll() {
		String query = "select category.id, category.name, "
				+ "category.language from category as category";
		Collection all = new ArrayList();
		
		queryCategoriesCollection(query, all);

		return all;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryRepository#searchByLanguage(java.lang.Integer)
	 */
	public Collection searchByLanguage(Integer languageID) {
		String query = "select category.id, category.name, "
				+ "category.language from Category as category "
				+ "where category.language = " + languageID;
		Collection all = new ArrayList();
		
		queryCategoriesCollection(query, all);

		return all;
	}
	
	/*
	 * metodos privados
	 * metodos extraidos
	 */
	
	private Category queryCategory(String query, Category category) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			category = new Category((Integer) array[0], (String) array[1],
					(Language) array[2]);
		}
		return category;
	}
	
	private void queryCategoriesCollection(String query, Collection all) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			Category category = new Category((Integer) array[0],
					(String) array[1], (Language) array[2]);
			all.add(category);
		}
	}

}
