package com.efetiva.wiiser.server.repository;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.hibernate.Query;
import org.hibernate.Session;

import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.CategoryService;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.repository.interfaceRepository.ICategoryServiceRepository;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public class CategoryServiceRepository implements ICategoryServiceRepository {

	/***************************************************************************
	 * Constructor of categoryServiceRepository
	 * 
	 */
	public CategoryServiceRepository() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryServiceRepository#register(com.efetiva.wiser.entity.CategoryService)
	 */
	public void register(CategoryService categoryService) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.save(categoryService);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryServiceRepository#search(java.lang.Integer)
	 */
	public CategoryService search(Integer categoryID, Integer serviceID) {
		String query = "select categoryService.service, categoryService.category "
				+ "from CategoryService as categoryService where categoryService.service.id = "
				+ serviceID
				+ " and categoryService.category.id = "
				+ categoryID;
		CategoryService categoryService = null;

		categoryService = queryCategoryService(query, categoryService);
		
		return categoryService;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryServiceRepository#remove(com.efetiva.wiser.entity.CategoryService)
	 */
	public void remove(CategoryService categoryService) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.delete(categoryService);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryServiceRepository#searchAll()
	 */
	public Collection searchAll() {
		String query = "select categoryService.service, categoryService.category "
				+ "from CategoryService as categoryService";
		Collection all = new ArrayList();

		queryCategoryServicesCollection(query, all);
		
		return all;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.ICategoryServiceRepository#searchForService(java.lang.Integer)
	 */
	public Collection searchByService(Integer ID_Service) {
		String query = "select categoryService.service, categoryService.category "
				+ "from CategoryService as categoryService where categoryService.service.id = "
				+ ID_Service;
		Collection all = new ArrayList();

		queryCategoryServicesCollection(query, all);

		return all;
	}

	public void removeByService(Integer serviceID) {
		String query = "delete from CategoryService as categoryService "
				+ "where categoryService.service.id = " + serviceID;

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.createQuery(query);
	}
	
	/*
	 * metodos privados
	 * metodos extridos
	 */
	
	private CategoryService queryCategoryService(String query,
			CategoryService categoryService) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			categoryService = new CategoryService((Service) array[0],
					(Category) array[1]);
		}
		return categoryService;
	}
	
	private void queryCategoryServicesCollection(String query, Collection all) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			CategoryService categoryService = new CategoryService(
					(Service) array[0], (Category) array[1]);
			all.add(categoryService);
		}
	}
	
}
