package com.efetiva.wiiser.server.repository;

import java.util.Collection;
import java.util.Iterator;

import org.hibernate.Query;
import org.hibernate.Session;

import com.efetiva.wiiser.server.entity.Map;
import com.efetiva.wiiser.server.repository.interfaceRepository.IMapRepository;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public class MapRepository implements IMapRepository {

	/***************************************************************************
	 * Constructor of MapRepository
	 * 
	 */
	public MapRepository() {
	}

	/***************************************************************************
	 * Stores a Map object in the DB
	 * 
	 * @param map
	 *            map to be stored
	 */
	public void register(Map map) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.save(map);

	}

	/***************************************************************************
	 * Returns a Map object searched by its identification in the DB.
	 * <p>
	 * If the Map isn't found it returns null.
	 * 
	 * @param ID
	 *            the identification in the DB
	 * @return a Map object
	 */
	public Map search(Integer ID) {
		String query = "select map.id, map.photo, map.bitMask from Map as map where map.id = "
				+ ID;
		Map map = null;

		map = queryMap(query, map);

		return map;
	}
		
	/***************************************************************************
	 * Updates a Map object in the DB
	 * 
	 * @param map
	 *            map to be updated
	 */
	public void modify(Map map) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.update(map);

	}
	
	/*
	 * metodos privados
	 * metodos extraidos 
	 */
	
	private Map queryMap(String query, Map map) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			map = new Map((Integer) array[0], (String) array[1],
					(String) array[2]);
		}
		return map;
	}


}
