package com.efetiva.wiiser.server.repository;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.hibernate.Query;
import org.hibernate.Session;

import com.efetiva.wiiser.server.entity.Area;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.PlaceArea;
import com.efetiva.wiiser.server.repository.interfaceRepository.IPlaceAreaRepository;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public class PlaceAreaRepository implements IPlaceAreaRepository {

	/***************************************************************************
	 * Constructor of PlaceAreaRepository
	 * 
	 */
	public PlaceAreaRepository() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#register(wisser.server.entity.PlaceArea)
	 */
	public void register(PlaceArea placeArea) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.save(placeArea);
	}

	public PlaceArea search(Integer id){
		String query = "select placeArea.id, placeArea.place, placeArea.area, placeArea.coordX, "
			+ "placeArea.coordY from PlaceArea as placeArea where "
			+ "placeArea.id = " + id;
		PlaceArea placeArea = null;
		
		placeArea = queryPlaceArea(query, placeArea);
		
		return placeArea;
	}
		
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#search(java.lang.Integer,
	 *      java.lang.Integer)
	 */
	public PlaceArea searchByPlaceArea(Integer placeID, Integer areaID) {
		String query = "select placeArea.id, placeArea.place, placeArea.area, placeArea.coordX, "
				+ "placeArea.coordY from PlaceArea as placeArea where "
				+ "placeArea.place.id = "
				+ placeID
				+ " and placeArea.area.id = " + areaID;
		PlaceArea placeArea = null;
		
		placeArea = queryPlaceArea(query, placeArea);
		
		return placeArea;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#remove(wisser.server.entity.PlaceArea)
	 */
	public void remove(PlaceArea placeArea) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.delete(placeArea);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#modify(wisser.server.entity.PlaceArea)
	 */
	public void modify(PlaceArea placeArea) {

		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.update(placeArea);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#searchAll(java.lang.Integer)
	 */
	public Collection searchAll() {
		String query = "select placeArea.id, placeArea.place, placeArea.area, placeArea.coordX, "
				+ "placeArea.coordY from PlaceArea as placeArea";
		Collection all = new ArrayList();

		queryPlaceAreasCollection(query, all);
		
		return all;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#searchByArea(java.lang.Integer)
	 */
	public Collection searchByArea(Integer areaID, Integer languageID) {
		String query = "select placeArea.id, placeArea.place, placeArea.area, placeArea.coordX, "
				+ "placeArea.coordY from PlaceArea as placeArea "
				+ "where placeArea.area.id = " + areaID
				+ " and placeArea.place.language.id = " + languageID;
		Collection all = new ArrayList();

		queryPlaceAreasCollection(query, all);

		return all;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see wiiser.server.repository.IPlaceAreaRepository#searchByPlace(java.lang.Integer)
	 */
	public Collection searchByPlace(Integer placeID) {
		String query = "select placeArea.id, placeArea.place, placeArea.area, placeArea.coordX, "
				+ "placeArea.coordY from PlaceArea as placeArea "
				+ "where placeArea.place.id = " + placeID;
		Collection all = new ArrayList();

		queryPlaceAreasCollection(query, all);

		return all;
	}

	public void removeByPlace(Integer placeID) {
		String query = "delete from PlaceArea as placeArea where placeArea.place.id = "
				+ placeID;
		Session currentSession = HibernateUtil.getCurrentSession();
		currentSession.createQuery(query);
	}
	
	/*
	 * metodos privados
	 * metodos extraidos
	 */
	
	private PlaceArea queryPlaceArea(String query, PlaceArea placeArea) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			placeArea = new PlaceArea((Integer)array[0], (Place) array[1], (Area) array[2],
						(Integer) array[3], (Integer) array[4]);
		}
		return placeArea;
	}
	
	private void queryPlaceAreasCollection(String query, Collection all) {
		Session currentSession = HibernateUtil.getCurrentSession();
		Query q = currentSession.createQuery(query);
		Collection coll = q.list();
		Iterator iterator = coll.iterator();
		while (iterator.hasNext()) {
			Object obj = (Object) iterator.next();
			Object[] array = (Object[]) obj;
			PlaceArea placeArea = new PlaceArea((Integer) array[0], (Place) array[1], (Area) array[2],
												(Integer) array[3], (Integer) array[4]);
			all.add(placeArea);
		}
	}
	
}
