package com.efetiva.wiiser.server.repository.interfaceBusiness;

import java.util.Collection;
import java.util.Date;

import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public interface IActivityControl {

	/**
	 * 
	 * @param activity
	 * @throws NonExistingObjectException
	 * @throws NullObjectException
	 * @throws ExistingObjectException
	 */
	public void modify(Activity activity, Collection categories,
			Collection schedules) throws NonExistingObjectException,
			ExistingObjectException, NullObjectException;

	/**
	 * 
	 * @param activity
	 * @throws ExistingObjectException
	 * @throws NullObjectException
	 */
	public void register(Activity activity, Collection categoryActivity,
			Collection scheduleActivities) throws ExistingObjectException,
			NullObjectException;

	/**
	 * 
	 * @param activity
	 * @throws NonExistingObjectException
	 * @throws NullObjectException
	 */
	public void remove(Activity activity) throws NonExistingObjectException,
			NullObjectException;

	/**
	 * 
	 * @param ID
	 * @return
	 * @throws NonExistingObjectException
	 * @throws NullObjectException 
	 */
	public Activity search(Integer ID) throws NonExistingObjectException, NullObjectException;

	/**
	 * 
	 * @param date
	 * @param languageID
	 * @return
	 * @throws NullObjectException 
	 */
	public Collection searchByDate(Date date, Integer languageID) throws NullObjectException;

	/**
	 * 
	 * @param placeID
	 * @return
	 * @throws NullObjectException 
	 */
	public Collection searchByArea(Integer areaID, Integer languageID) throws NullObjectException;

	/**
	 * 
	 * @param placeID
	 * @return
	 * @throws NullObjectException 
	 */
	public Collection searchByPlace(Integer placeID) throws NullObjectException;

	/**
	 * 
	 * @return
	 */
	public Collection searchAll();

	/**
	 * 
	 * @return
	 * @throws NullObjectException 
	 */
	public Collection searchByLanguage(Integer languageID) throws NullObjectException;

	/**
	 * Return an Activity object with the name in parameter
	 * 
	 * @param name
	 * @return Activity
	 * @throws NullObjectException 
	 */
	public Activity searchByName(String name, Integer languageID) throws NullObjectException;

}