package com.efetiva.wiiser.server.repository.interfaceBusiness;

import java.util.Collection;



import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public interface ILanguageControl {

	/**
	 * @throws NonExistingObjectException 
	 * @throws NullObjectException 
	 * 
	 */
	public void modify(Language language) throws NonExistingObjectException, NullObjectException;

	/**
	 * @throws ExistingObjectException 
	 * @throws NullObjectException 
	 * 
	 */
	public void register(Language language) throws ExistingObjectException, NullObjectException;

	/**
	 * @throws NonExistingObjectException 
	 * @throws NullObjectException 
	 * 
	 */
	public void remove(Language language) throws NonExistingObjectException, NullObjectException;

	/**
	 * @throws NullObjectException 
	 * 
	 */
	public Language search(Integer ID) throws NullObjectException;
	
	/**
	 * @throws NullObjectException 
	 * 
	 */
	public Language searchByName(String name) throws NullObjectException;

	/**
	 * 
	 */
	public Collection searchAll();

}