package com.efetiva.wiiser.server.repository.interfaceBusiness;



import com.efetiva.wiiser.server.entity.Map;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public interface IMapControl {

	/***
	 * Stores a Map object in the DB
	 * 
	 * @param	map	map to be stored
	 * @throws ExistingObjectException 
	 * @throws NullObjectException 
	 */
	public void register(Map map) throws ExistingObjectException, NullObjectException;

	/***
	 * Returns a Map object searched by its
	 * identification in the DB.
	 *  
	 * @param	ID	the identification in the DB
	 * @return		a Map object
	 * @throws NullObjectException 
	 */
	public Map search(Integer ID) throws NullObjectException;

	/***
	 * Updates a Map object in the DB
	 * 
	 * @param	map	map to be updated
	 * @throws NonExistingObjectException 
	 * @throws NullObjectException 
	 */
	public void modify(Map map) throws NonExistingObjectException, NullObjectException;

}