package com.efetiva.wiiser.server.repository.interfaceBusiness;

import java.util.Collection;


import com.efetiva.wiiser.server.entity.PlaceArea;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public interface IPlaceAreaControl {
	
	/**
	 * 
	 * @param placeArea
	 * @throws ExistingObjectException
	 * @throws NullObjectException
	 */
	public void register(PlaceArea placeArea)
			throws ExistingObjectException, NullObjectException;

	/**
	 * 
	 * @param placeArea
	 * @throws NonExistingObjectException
	 * @throws NullObjectException
	 */
	public void remove(PlaceArea placeArea)
			throws NonExistingObjectException, NullObjectException;

	
	/**
	 * 
	 * @param id
	 * @return
	 * @throws NullObjectException 
	 */
	public PlaceArea search(Integer id) throws NullObjectException;
	
	
	/**
	 * 
	 * @param placeID
	 * @param areaID
	 * @return
	 * @throws NullObjectException
	 */
	public PlaceArea searchByPlaceArea(Integer placeID, Integer areaID)
			throws NullObjectException;
	
	/**
	 * 
	 * @param placeArea
	 * @throws NonExistingObjectException
	 * @throws NullObjectException
	 */
	public void modify(PlaceArea placeArea) throws NonExistingObjectException,
	NullObjectException;

	/**
	 * 
	 * @param languageID
	 * @return
	 * @throws NullObjectException
	 */
	public Collection searchAll();

	/**
	 * 
	 * @param placeID
	 * @return
	 * @throws NullObjectException
	 */
	public Collection searchByPlace(Integer placeID)
			throws NullObjectException;

	public Collection searchByArea(Integer areaID, Integer languageID)
			throws NullObjectException;

}