package com.efetiva.wiiser.server.repository.interfaceBusiness;

import java.util.Collection;
import java.util.Date;


import com.efetiva.wiiser.server.entity.ScheduleInfo;
import com.efetiva.wiser.exception.NullObjectException;

public interface IScheduleInfoControl {
	
	/***
	 * Stores a ScheduleInfo object in the DB
	 * 
	 * @param	schedule	ScheduleInfo to be stored
	 * @throws NullObjectException 
	 * @throws NullObjectException 
	 */
	public void register(ScheduleInfo schedule) throws NullObjectException;

	/***
	 * Returns a ScheduleInfo object searched by its
	 * identification in the DB.
	 *  
	 * @param	ID	the identification in the DB
	 * @return		a ScheduleInfo object
	 * @throws NullObjectException 
	 */
	public Collection searchByDynamicInfo(Integer ID) throws NullObjectException;

	/***
	 * Removes a ScheduleInfo object from the DB
	 * 
	 * @param	schedule	ScheduleInfo to be removed
	 * @throws NullObjectException 
	 * @throws NullObjectException 
	 */
	public void remove(ScheduleInfo schedule) throws NullObjectException;

	/***
	 * Updates a ScheduleInfo object in the DB
	 * 
	 * @param	schedule	ScheduleInfo to be updated
	 * @throws NullObjectException 
	 */
	public void modify(ScheduleInfo schedule) throws NullObjectException;
	
	/**
	 * Searches all existing ScheduleInfo
	 * @return	a ScheduleInfo object collection
	 */
	public Collection searchAll();

	public void removeByDynamicInfo(Integer infoID) throws NullObjectException;

	public Collection searchByHour(Date date) throws NullObjectException;
	
}
