package com.efetiva.wiiser.server.repository.interfaceBusiness;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.ScheduleService;
import com.efetiva.wiser.exception.NullObjectException;



public interface IScheduleServiceControl {

	/***************************************************************************
	 * Stores a ScheduleService object in the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be stored
	 * @throws NullObjectException 
	 */
	public void register(ScheduleService schedule) throws NullObjectException;

	/***************************************************************************
	 * Removes a ScheduleService object from the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be removed
	 * @throws NullObjectException 
	 */
	public void remove(ScheduleService schedule) throws NullObjectException;
	
	/***************************************************************************
	 * Search a ScheduleService object from the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be removed
	 * @throws NullObjectException 
	 */
	public ScheduleService search(Integer id) throws NullObjectException;

	/***************************************************************************
	 * Updates a ScheduleService object in the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be updated
	 * @throws NullObjectException 
	 */
	public void modify(ScheduleService schedule) throws NullObjectException;

	/***************************************************************************
	 * Returns a collection of ScheduleService object searched by service
	 * identification in the DB.
	 * 
	 * @param ID
	 *            service identification in the DB
	 * @return a ScheduleService object
	 * @throws NullObjectException 
	 */
	public Collection searchByService(Integer serviceID) throws NullObjectException;
	
	public Collection searchAll();
	
	public void removeByService(Integer serviceID) throws NullObjectException;

}
