package com.efetiva.wiiser.server.repository.interfaceBusiness;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiser.exception.NonExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;


public interface IUserControl {

	/***
	 * Stores a User object in the DB
	 * 
	 * @param	user	user to be stored
	 * @throws NullObjectException 
	 */
	public void register(User user) throws NullObjectException;

	/***
	 * Returns a User object searched by its
	 * username (identification in the DB).
	 *  
	 * @param	username	username that is the identification in the DB
	 * @return				a User object
	 * @throws NullObjectException 
	 */
	public User search(String username) throws NullObjectException;

	/***
	 * Removes a User object from the DB
	 * 
	 * @param	user	user to be removed
	 * @throws NullObjectException 
	 */
	public void remove(User user) throws NullObjectException;

	/***
	 * Updates a User object in the DB
	 * 
	 * @param	user	user to be updated
	 * @throws NonExistingObjectException 
	 * @throws NullObjectException 
	 */
	public void modify(User user) throws NonExistingObjectException, NullObjectException;

	public Collection searchAll();

}