package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.Area;


public interface IAreaRepository {

	/***************************************************************************
	 * Stores an Area object in the DB.
	 * 
	 * @param area
	 *            area to be stored
	 */
	public void register(Area area);

	/***************************************************************************
	 * Returns an Area object searched by its identification in the DB.
	 * 
	 * @param ID
	 *            the identification in the DB
	 * @return an Area object
	 */
	public Area search(Integer id);

	/***************************************************************************
	 * Removes an Area object from the DB
	 * 
	 * @param area
	 *            area to be removed
	 */
	public void remove(Area area);

	/***************************************************************************
	 * Updates an Area object in the DB
	 * 
	 * @param area
	 *            area to be updated
	 */
	public void modify(Area area);

	/***************************************************************************
	 * Returns a collection of all Area object stored in the DB.
	 * 
	 * @return an Area collection
	 */
	public Collection searchAll();

	/***************************************************************************
	 * Returns a collection of all Area object stored in the DB with the
	 * specific language.
	 * 
	 * @return an Area collection
	 */
	public Collection searchByLanguage(Integer languageID);

	public Area searchByName(String name);

}