package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.CategoryService;



public interface ICategoryServiceRepository {

	/***************************************************************************
	 * Stores a categoryService object in the DB
	 * 
	 * @param categoryService
	 *            categoryService to be stored
	 */
	public void register(CategoryService categoryService);

	/***************************************************************************
	 * Returns a categoryService object searched by its identification in the
	 * DB.
	 * <p>
	 * If the categoryService isn't found it returns null.
	 * 
	 * @param ID
	 *            the identification in the DB
	 * @return a categoryService object
	 */
	public CategoryService search(Integer ID_SubCategory, Integer ID_Service);

	/***************************************************************************
	 * Removes a categoryService object from the DB
	 * 
	 * @param categoryService
	 *            categoryService to be removed
	 */
	public void remove(CategoryService categoryService);

	/***************************************************************************
	 * Returns a collection of all categoryService object stored in the DB.
	 * <p>
	 * If any categoryService isn't found it returns an empty collection.
	 * 
	 * @return a categoryService collection
	 */
	public Collection searchAll();
	
	/***************************************************************************
	 * Returns a collection of all categoryService object stored in the DB 
	 * 		with the specific Service ID.
	 * <p>
	 * If any categoryService isn't found it returns an empty collection.
	 * 
	 * @return a categoryService collection
	 */
	public Collection searchByService(Integer ID_Service);
	
	public void removeByService(Integer serviceID);
	
}