package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.DynamicInfo;



public interface IDynamicInfoRepository {

	/***
	 * Stores a DynamicInfo object in the DB
	 * 
	 * @param	dynamicInfo	DynamicInfo to be stored
	 */
	public void register(DynamicInfo info);

	/***
	 * Returns a DynamicInfo object searched by its
	 * identification in the DB.
	 *  
	 * @param	ID	the identification in the DB
	 * @return		a DynamicInfo object
	 */
	public DynamicInfo search(Integer ID);

	/***
	 * Removes a DynamicInfo object from the DB
	 * 
	 * @param	info	DynamicInfo to be removed
	 */
	public void remove(DynamicInfo info);

	/***
	 * Updates a DynamicInfo object in the DB
	 * 
	 * @param	info	DynamicInfo to be updated
	 */
	public void modify(DynamicInfo info);

	/***
	 * Returns a collection of all DynamicInfo object stored in
	 * the DB.
	 * 
	 * @return	a DynamicInfo collection
	 */
	public Collection searchAll();
	
	/***
	 * Returns a collection of all DynamicInfo object stored in
	 * the DB with the specific languageID.
	 * 
	 * @return	a DynamicInfo collection
	 */
	public Collection searchByLanguage(Integer languageID);
	
	
	public DynamicInfo selectMaxId();

}