package com.efetiva.wiiser.server.repository.interfaceRepository;

import com.efetiva.wiiser.server.entity.Map;

public interface IMapRepository {

	/***
	 * Stores a Map object in the DB
	 * 
	 * @param	map	map to be stored
	 */
	public void register(Map map);

	/***
	 * Returns a Map object searched by its
	 * identification in the DB.
	 *  
	 * @param	ID	the identification in the DB
	 * @return		a Map object
	 */
	public Map search(Integer ID);

	/***
	 * Updates a Map object in the DB
	 * 
	 * @param	map	map to be updated
	 */
	public void modify(Map map);

}