package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.Place;





public interface IPlaceRepository {

	/***
	 * Stores a Place object in the DB
	 * 
	 * @param	place	place to be stored
	 */
	public void register(Place place);

	/***
	 * Returns a Place object searched by its
	 * identification in the DB.
	 *  
	 * @param	ID	the identification in the DB
	 * @return		a Place object
	 */
	public Place search(Integer ID);
	
	/***
	 * Returns a Place object searched by its
	 * name in the DB.
	 *  
	 * @param	plakceName	the name in the DB
	 * @return		a Place object
	 */
	public Place searchByName(String name, Integer languageID);

	/***
	 * Removes a Place object from the DB
	 * 
	 * @param	place	place to be removed
	 */
	public void remove(Place place);

	/***
	 * Updates a Place object in the DB
	 * 
	 * @param	place	place to be updated
	 */
	public void modify(Place place);

	/***
	 * Returns a collection of all Place object stored in
	 * the DB.
	 * 
	 * @return	a Place collection
	 */
	public Collection searchAll();
	
	/***
	 * Returns a collection of all Place object stored in
	 * the DB.
	 * 
	 * @param languageID
	 * @return	a Place collection
	 */
	public Collection searchByLanguage(Integer languageID);

}