package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.ScheduleActivity;



public interface IScheduleActivityRepository {

	/***************************************************************************
	 * Stores a ScheduleActivity object in the DB
	 * 
	 * @param schedule
	 *            ScheduleActivity to be stored
	 */
	public void register(ScheduleActivity schedule);

	/***************************************************************************
	 * Removes a ScheduleActivity object from the DB
	 * 
	 * @param schedule
	 *            ScheduleActivity to be removed
	 */
	public void remove(ScheduleActivity schedule);

	/***************************************************************************
	 * Updates a ScheduleActivity object in the DB
	 * 
	 * @param schedule
	 *            ScheduleActivity to be updated
	 */
	public void modify(ScheduleActivity schedule);

	/**
	 * Searches all existing ScheduleActivity
	 * 
	 * @return a ScheduleActivity object collection
	 */
	public Collection searchAll();

	/***************************************************************************
	 * Returns a collection of ScheduleActivity object searched by service
	 * identification in the DB.
	 * 
	 * @param ID
	 *            activity identification in the DB
	 * @return a ScheduleActivity object
	 */
	public Collection searchByActivity(Integer ID);
	
	/***************************************************************************
	 * Returns a collection of ScheduleActivity object searched by service
	 * name in the DB.
	 * 
	 * @param placeName
	 *            activity name in the DB
	 * @return a ScheduleActivity object
	 */
	public Collection searchByActivityName(String ID, Integer language);
	
	public void removeByActivity(Integer activityID);

	public ScheduleActivity search(Integer scheduleID);
}
