package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;
import java.util.Date;

import com.efetiva.wiiser.server.entity.ScheduleInfo;



public interface IScheduleInfoRepository {

	/***
	 * Stores a ScheduleInfo object in the DB
	 * 
	 * @param	schedule	ScheduleInfo to be stored
	 */
	public void register(ScheduleInfo schedule);

	/***
	 * Removes a ScheduleInfo object from the DB
	 * 
	 * @param	schedule	ScheduleInfo to be removed
	 */
	public void remove(ScheduleInfo schedule);

	/***
	 * Updates a ScheduleInfo object in the DB
	 * 
	 * @param	schedule	ScheduleInfo to be updated
	 */
	public void modify(ScheduleInfo schedule);
	
	/**
	 * Searches all existing ScheduleInfo
	 * @return	a ScheduleInfo object collection
	 */
	public Collection searchAll();
	
	/**
	 * Searches all existing ScheduleInfo with Specific DynamicInfo id
	 * 
	 * @return a ScheduleInfo object collection
	 */
	public Collection searchByDynamicInfo(Integer id);

	public void removeByDynamicInfo(Integer infoID);

	public Collection searchByHour(Date date);
}
