package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.ScheduleService;



public interface IScheduleServiceRepository {

	/***************************************************************************
	 * Stores a ScheduleService object in the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be stored
	 */
	public void register(ScheduleService schedule);

	/***************************************************************************
	 * Removes a ScheduleService object from the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be removed
	 */
	public void remove(ScheduleService schedule);

	/***************************************************************************
	 * Updates a ScheduleService object in the DB
	 * 
	 * @param schedule
	 *            ScheduleService to be updated
	 */
	public void modify(ScheduleService schedule);

	/***************************************************************************
	 * Returns a collection of ScheduleService object searched by service
	 * identification in the DB.
	 * 
	 * @param ID
	 *            service identification in the DB
	 * @return a ScheduleService object
	 */
	public Collection searchByService(Integer ID);
	
	public ScheduleService search(Integer id);
	
	public Collection searchAll();

	public void removeByService(Integer serviceID);

}
