package com.efetiva.wiiser.server.repository.interfaceRepository;

import java.util.Collection;

import com.efetiva.wiiser.server.entity.User;


public interface IUserRepository {

	/***
	 * Stores a User object in the DB
	 * 
	 * @param	user	user to be stored
	 */
	public void register(User user);

	/***
	 * Returns a User object searched by its
	 * username (identification in the DB).
	 *  
	 * @param	username	username that is the identification in the DB
	 * @return				a User object
	 */
	public User search(String username);

	/***
	 * Removes a User object from the DB
	 * 
	 * @param	user	user to be removed
	 */
	public void remove(User user);

	/***
	 * Updates a User object in the DB
	 * 
	 * @param	user	user to be updated
	 */
	public void modify(User user);

	public Collection searchAll();

}