package com.efetiva.wiiser.server.singleton;

import org.hibernate.Transaction;

import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;

public aspect PersistenceAspect {

	pointcut transactionExecution():
		execution(public * Facade.*(..));
	
	private Transaction tx;
	
	before(): transactionExecution() {
		tx = HibernateUtil.getCurrentSession().beginTransaction();
	}
	
	after() returning() : transactionExecution() {
		tx.commit();
		HibernateUtil.closeSession();
	}
	
	after() throwing() : transactionExecution() {
		tx.rollback();
		HibernateUtil.closeSession();
	}
}
