package com.efetiva.wiiser.server.tests;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import org.hibernate.HibernateException;


import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiiser.server.entity.Area;
import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.CategoryActivity;
import com.efetiva.wiiser.server.entity.CategoryPlace;
import com.efetiva.wiiser.server.entity.CategoryService;
import com.efetiva.wiiser.server.entity.DynamicInfo;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Map;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.ScheduleActivity;
import com.efetiva.wiiser.server.entity.ScheduleInfo;
import com.efetiva.wiiser.server.entity.ScheduleService;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.server.util.hibernate.HibernateUtil;
import com.efetiva.wiser.exception.ExistingObjectException;
import com.efetiva.wiser.exception.NullObjectException;

public class Tests {

	public static DynamicInfo ttt(DynamicInfo d, Integer b) throws ExistingObjectException, NullObjectException {
		// tirar os hibernateutil.closeSession() e as transactions.
		org.hibernate.Session session = null;
		org.hibernate.Transaction tx = null;
		DynamicInfo dynamicInfo = null;
		try {
			session = HibernateUtil.getCurrentSession();
			tx = session.beginTransaction();
			Facade f = Facade.getInstance();
			f.registerDynamicInfo(d, null);
			dynamicInfo = f.searchDynamicInfo(b);
			tx.commit();
		} catch (HibernateException e) {
			if (tx != null) {
				try {
					tx.rollback();
				} catch (HibernateException e1) {
					e1.printStackTrace();
				}
			}
			e.printStackTrace();
		} finally {
			HibernateUtil.closeSession();
		}
		return dynamicInfo;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Facade f = Facade.getInstance();
		

		Language l = new Language();
		l.setId(new Integer(1));
		l.setName("Portugu");
		try {
			Language la = f.searchLanguage(new Integer(1));
			System.out.println(la.getName());
		} catch (NullObjectException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		Category c = new Category();
		c.setId(new Integer(1));
		c.setLanguage(l);
		c.setName("categore");

		Map m = new Map();
		m.setBitMask("fads");
		m.setId(new Integer(1));
		m.setPhoto("fads");

		Area ar = new Area();
		ar.setCoordX(new Integer(1));
		ar.setCoordY(new Integer(2));
		ar.setDescription("dflaks");
		ar.setId(new Integer(1));
		ar.setLanguage(l);
		ar.setMap(m);
		ar.setName("aaaaaaaaa");
		ar.setPhoto("fasd");

		Place p = new Place();
		p.setDescription("fafdsaasdfdf");
		p.setId(new Integer(2));
		p.setLanguage(l);
		p.setName("ndsafad");
		p.setPhoto("fadadfs");

		CategoryPlace cp = new CategoryPlace();
		cp.setPlace(p);
		cp.setCategory(c);
		Collection collCatPla = new ArrayList();
		collCatPla.add(cp);

		DynamicInfo d = new DynamicInfo();
		d.setId(new Integer(5));
		d.setDescription("teste");
		d.setLanguage(l);

		ScheduleInfo si = new ScheduleInfo();
		si.setDynamicInfo(d);
		si.setDayOfWeek(new Integer(555));
		si.setHour("");
		Collection collSchInf = new ArrayList();
		collSchInf.add(si);

		Activity a = new Activity();
		a.setDescription("fdas");
		a.setId(new Integer(2));
		a.setIsActive(new Integer(1));
		a.setLanguage(l);
		a.setName("aaaaaaaaaaatividade");
		a.setPhoto("dsa");
		a.setPlace(p);
		a.setValue(new Double(4));

		CategoryActivity ca = new CategoryActivity();
		ca.setActivity(a);
		ca.setCategory(c);
		Collection collCatAct = new ArrayList();
		collCatAct.add(ca);

		ScheduleActivity sa = new ScheduleActivity();
		sa.setActivity(a);
		sa.setDayOfWeek(new Integer(555));
		sa.setHour(new Date());
		Collection collSchAct = new ArrayList();
		collSchAct.add(sa);

		Service se = new Service();
		se.setDescription("fdas");
		se.setId(new Integer(2));
		se.setIsActive(new Integer(1));
		se.setLanguage(l);
		se.setName("aaaaaaaaaaaservio");
		se.setPhoto("dsa");
		se.setPlace(p);
		se.setValue(new Double(4));

		CategoryService cs = new CategoryService();
		cs.setService(se);
		cs.setCategory(c);
		Collection collCatSer = new ArrayList();
		collCatSer.add(cs);

		ScheduleService ss = new ScheduleService();
		ss.setService(se);
		ss.setDayOfWeek(new Integer(1));
		ss.setHourInitial(new Date());
		Collection collSchSer = new ArrayList();
		collSchSer.add(ss);

	}
}
