package com.efetiva.wiiser.server.util.hibernate;

import java.sql.*;

/*
 * Created on 13/03/2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */


/**
 * @author Felipe C. Ferreira
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */

public class GerenciadorTransacoes {

	private GerenciadorConexoes conexoes;

	private static GerenciadorTransacoes gerenciador;

	private GerenciadorTransacoes() throws TransacaoException {
		try {
			this.conexoes = GerenciadorConexoes.getInstance();
		} catch (PersistenciaException e) {
			throw new TransacaoException(
					"Impossivel obter instancia do gerenciador de transacoes - "
							+ e.getMessage());
		}
	}

	public static GerenciadorTransacoes getInstance() throws TransacaoException {
		if (gerenciador == null) {
			gerenciador = new GerenciadorTransacoes();
		}
		return gerenciador;
	}

	public Connection getConexaoTransacao() throws PersistenciaException {
		return this.conexoes.getConnection(Thread.currentThread());
	}

	public void liberarConexaoTransacao() throws PersistenciaException {

		try {
			if (conexoes.getConnection(Thread.currentThread()).getAutoCommit()) {
				this.conexoes.freeConnection(Thread.currentThread());
			}
		} catch (SQLException e) {
			throw new PersistenciaException("Conexo no liberada");
		}

	}

	public synchronized void iniciarTransacao() throws TransacaoException {
		try {
			this.conexoes.getConnection(Thread.currentThread()).setAutoCommit(
					false);
		} catch (SQLException e) {
			throw new TransacaoException("Transao nao pode ser iniciada - "
					+ e.getMessage());
		} catch (PersistenciaException e) {
			throw new TransacaoException("Transao nao pode ser iniciada - "
					+ e.getMessage());
		}
	}

	public synchronized void cancelarTransacao() throws TransacaoException {
		Connection conexao = null;
		try {
			conexao = this.conexoes.getConnection(Thread.currentThread());
			conexao.rollback();
			conexao.setAutoCommit(true);
			this.liberarConexaoTransacao();
		} catch (SQLException e) {
			throw new TransacaoException("Transao nao pode ser cancelada - "
					+ e.getMessage());
		} catch (PersistenciaException e) {
			throw new TransacaoException("Transao nao pode ser cancelada - "
					+ e.getMessage());
		}

	}

	public synchronized void confirmarTransacao() throws TransacaoException {
		Connection conexao = null;
		try {
			conexao = this.conexoes.getConnection(Thread.currentThread());
			conexao.commit();
			conexao.setAutoCommit(true);
			this.liberarConexaoTransacao();
		} catch (SQLException e) {
			throw new TransacaoException("Transao nao pode ser confirmada - "
					+ e.getMessage());
		} catch (PersistenciaException e) {
			throw new TransacaoException("Transao nao pode ser confirmada - "
					+ e.getMessage());
		}

	}
}