package com.efetiva.wiiser.webserver.gui;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public aspect GuiAspect {
	
	pointcut guiInvocation():
		execution(public ActionForward *.*Action.*(..));
	
	ActionForward around(): guiInvocation(){
		Object[] args = thisJoinPoint.getArgs();
		ActionMapping actionMapping = null;
		for(Object object:args){
			if(object instanceof ActionMapping){
				actionMapping = (ActionMapping)object;
			}			
			else if (object instanceof HttpServletRequest) {
				HttpServletRequest request = (HttpServletRequest)object;
				User userSession = (User) request.getSession().getAttribute(
						SystemConstants.USER);
				if(userSession == null){
					return actionMapping
					.findForward(SystemConstants.FORWARD_NOT_LOGGED);
				}				
			}
		}
		return proceed();
	}

}
