package com.efetiva.wiiser.webserver.gui.activity;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.Functions;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ActivityChangeAction extends ObjectAction {

	public static String USER_CASE = ActivityChangeAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityChangeActionForm form = (ActivityChangeActionForm) requestActionForm;

		Integer activityId = new Integer(request.getParameter("activityId"));
		request.getSession().setAttribute("idActivity", activityId);

		Activity act = new Activity();
		if (activityId != null) {
			act = Facade.getInstance().searchActivity(activityId);
		}
		form.setActivity(act);
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		form.setLanguage(act.getLanguage().getId().toString());

		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(
				act.getLanguage().getId());
		form.setCollPlace(collPlaces);
		form.setPlace(act.getPlace().getId().toString());
		form.setDescription(act.getDescription());
		form.setIsActive(act.getIsActive().toString());
		form.setName(act.getName());
		form.setValue(act.getValue().toString());

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityChangeActionForm form = (ActivityChangeActionForm) requestActionForm;

		Integer cod = null;
		if (!"".equals(form.getLanguage())) {
			cod = new Integer(form.getLanguage());

		}

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		Collection collPlaces = Facade.getInstance()
				.searchPlacesByLanguage(cod);
		form.setCollPlace(collPlaces);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityChangeActionForm form = (ActivityChangeActionForm) requestActionForm;

		Integer id = (Integer)(request.getSession().getAttribute("idActivity"));
		request.getSession().removeAttribute("idActivity");
		
		String name = form.getName();
		String description = form.getDescription();
		FormFile file = form.getPhoto();
		String placeId = form.getPlace();
		String value = form.getValue();
		
		if(value.equals("")){
			form.setValue("0,00");
			value = "0,00";
		}
		
		Integer codigo = null;
		if (!"".equals(form.getLanguage())) {
			codigo = new Integer(form.getLanguage());
		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		
		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(codigo);
		form.setCollPlace(collPlaces);
		
		if(collPlaces.isEmpty()){
			return actionMapping.findForward(SystemConstants.FORWARD_NOT_SELECTED);
		}
		
		Activity a = Facade.getInstance().searchActivityByName(name, codigo);
		if((a != null) && (a.getId().intValue() != id.intValue())){
			return actionMapping
				.findForward(SystemConstants.FORWARD_EXISTING_ACTIVITY_NAME);
		}
		
		Language l = Facade.getInstance().searchLanguage(codigo);
		Place p = Facade.getInstance().searchPlace(new Integer(placeId));
		
		Activity act = Facade.getInstance().searchActivity(id);
		if (act != null) {
			act.setDescription(form.getDescription());
			act.setName(name);
			act.setValue(Functions.parseDouble(value));
			act.setLanguage(l);
			act.setPlace(p);
			if (form.getIsActive().equals("1")) {
				act.setIsActive(new Integer(1));
			} else {
				act.setIsActive(new Integer(0));
			}
			Collection schedules = act.getSchedules();
			
			String fileToSavePath =  SystemConstants.ACTIVITY_IMAGES_FOLDER + 
				name + "-" + l.getName();
			String fileName = file.getFileName();
			if (!fileName.trim().equals("")) {
				String fileType = file.getContentType(); 
				if(fileType.equals("image/x-png")) {
					fileToSavePath += ".png";
				} else if (fileType.equals("image/jpg")) {
					fileToSavePath += ".jpg";
				} else if (fileType.equals("image/jpeg")){
					fileToSavePath += ".jpeg";
				} else if (fileType.equals("image/gif")){
					fileToSavePath += ".gif";
				} else {
					return actionMapping
					.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
				}
				
				Util.deleteFile(act.getPhoto());
				act.setPhoto(fileToSavePath);
				try{
					Util.storeFile(file.getFileData(), fileToSavePath);
				} catch (IOException ioEx){
					return actionMapping
					.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
				}
			} else {
				String fileType = act.getPhoto();
				
				if(fileType.contains(".png")) {
					fileToSavePath += ".png";
				} else if (fileType.contains(".jpg")) {
					fileToSavePath += ".jpg";
				} else if (fileType.contains(".jpeg")){
					fileToSavePath += ".jpeg";
				} else if (fileType.contains(".gif")){
					fileToSavePath += ".gif";
				}
				
				Util.renameFile(act.getPhoto(), fileToSavePath);
				act.setPhoto(fileToSavePath);
			}
			
			Facade.getInstance().modifyActivity(act, new ArrayList(), schedules);

			return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
		}
		else{
			return actionMapping.findForward("errorActivity");
		}		
	}
}
