package com.efetiva.wiiser.webserver.gui.activity;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.ScheduleActivity;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.exception.ExistingFileException;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.Functions;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ActivityRegisterAction extends ObjectAction {

	public static String USER_CASE = ActivityRegisterAction.class
			.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		form.setName("");
		form.setDescription("");
		form.setValue("0,00");
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		if(collLanguage.isEmpty()){
			request.getSession().setAttribute("messageError", "Para incluir uma atividades  preciso ter cadastrado pelo menos um idioma");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		form.setCollLanguage(collLanguage);
		Language l = null;
		if (collLanguage != null) {
			Iterator it = collLanguage.iterator();
			while (it.hasNext()) {
				l = (Language) it.next();
				break;
			}

		}
		otd.setLanguage(l);

		Collection collPlaces = Facade.getInstance().searchAllPlaces();
		if(collPlaces.isEmpty()){
			request.getSession().setAttribute("messageError", "Para incluir uma atividades  preciso ter cadastrado pelo menos uma sub-rea");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		Collection collPlacesByLanguage = Facade.getInstance().searchPlacesByLanguage(l.getId());
		form.setCollPlace(collPlacesByLanguage);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		Activity act = new Activity();
		act.setDescription(form.getDescription());
		act.setIsActive(new Integer(1));
		Language l = otd.getLanguage();
		act.setLanguage(l);
		act.setName(form.getName());
		
		String valueString = form.getValue();
		Double valor = 0.00;
		if(!valueString.equals("")){
			valor = Functions.parseDouble(valueString);
		}
		act.setValue(valor);

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(
				otd.getLanguage().getId());
		form.setCollPlace(collPlaces);
		if(!valueString.equals("")){
			form.setValue(valueString);
		} else {
			form.setValue("0,00");
		}
		
		if(collPlaces.isEmpty()){
			return actionMapping.findForward(SystemConstants.FORWARD_NOT_SELECTED);
		}
		
		Activity a = null;
		a = Facade.getInstance().searchActivityByName(act.getName(), act.getLanguage().getId());
		if (a != null) {
			return actionMapping.findForward("existService");
		}
		
		//file handle
		FormFile file = form.getPhoto();
		if (file.getFileName().trim().equals("")) {
			file.destroy();
			return actionMapping
			.findForward(SystemConstants.FORWARD_EMPTY_FILE_FIELD);
		}
		String fileToSavePath = SystemConstants.ACTIVITY_IMAGES_FOLDER + 
			act.getName() + "-" + act.getLanguage().getName();
		String fileType = file.getContentType(); 
		if(fileType.equals("image/x-png")) {
			fileToSavePath += ".png";
		} else if (fileType.equals("image/jpg")) {
			fileToSavePath += ".jpg";
		} else if (fileType.equals("image/jpeg")){
			fileToSavePath += ".jpeg";
		} else if (fileType.equals("image/gif")){
			fileToSavePath += ".gif";
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
		}
		
		act.setPhoto(fileToSavePath);
		otd.setFile(file.getFileData());
		
		Place p = Facade.getInstance()
				.searchPlace(new Integer(form.getPlace()));
		act.setPlace(p);

		otd.setActivity(act);

		Collection collSchedule = Facade.getInstance()
				.searchScheduleByActivity(act.getId());
		if (collSchedule != null) {
			otd.setCollSchedule(collSchedule);
		}
		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE);

	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		Integer cod = null;
		if (!"".equals(form.getLanguage())) {
			cod = new Integer(form.getLanguage());

		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = Facade.getInstance().searchLanguage(
				new Integer(form.getLanguage()));
		otd.setLanguage(l);
		Collection collPlaces = Facade.getInstance()
				.searchPlacesByLanguage(cod);
		form.setCollPlace(collPlaces);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward schedule(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE_JSP);

	}

	public ActionForward scheduleIFrame(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);
		return actionMapping
				.findForward(SystemConstants.FORWARD_SCHEDULE_JSP_FRAME);

	}

	public ActionForward scheduleAdd(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		String week = form.getWeekday().trim();
		Integer diaSemana = null;
		if (week.equalsIgnoreCase("Segunda-Feira")) {
			diaSemana = new Integer(1);
		} else if (week.equalsIgnoreCase("Tera-Feira")) {
			diaSemana = new Integer(2);
		} else if (week.equalsIgnoreCase("Quarta-Feira")) {
			diaSemana = new Integer(3);
		} else if (week.equalsIgnoreCase("Quinta-Feira")) {
			diaSemana = new Integer(4);
		} else if (week.equalsIgnoreCase("Sexta-Feira")) {
			diaSemana = new Integer(5);
		} else if (week.equalsIgnoreCase("Sbado")) {
			diaSemana = new Integer(6);
		} else if ((week.equalsIgnoreCase("Domingo"))) {
			diaSemana = new Integer(0);
		} else {
			diaSemana = new Integer(7);
		}
		
		int hora = Integer.parseInt(form.getHora().trim());
		int min = Integer.parseInt(form.getMinuto().trim());
		Date d = new Date();
		d.setHours(hora);
		d.setMinutes(min);
		
		if(diaSemana != 7){
			ScheduleActivity sa = new ScheduleActivity();
			sa.setActivity(otd.getActivity());
			sa.setDayOfWeek(diaSemana);
			sa.setHour(d);
			otd.addScheduleActivity(sa);
		} else {
			for(int i=0; i<7; i++){
				ScheduleActivity sa = new ScheduleActivity();
				sa.setActivity(otd.getActivity());
				sa.setDayOfWeek(new Integer(i));
				sa.setHour(d);
				otd.addScheduleActivity(sa);
			}
		}
	
		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE);

	}

	public ActionForward scheduleRemove(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		Integer posicao = new Integer(form.getPrymaryKey());
		otd.removeScheduleActivity(posicao);

		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE);
	}

	public ActionForward finish(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityRegisterActionForm form = (ActivityRegisterActionForm) requestActionForm;

		ActivityRegisterOTD otd = setOtd(request, form);

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = null;
		if (collLanguage != null) {
			Iterator it = collLanguage.iterator();
			while (it.hasNext()) {
				l = (Language) it.next();
				break;
			}

		}
		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(
				l.getId());
		form.setCollPlace(collPlaces);

		Activity act = otd.getActivity();
		act.setSchedules(otd.getCollSchedule());
		act.setLanguage(otd.getLanguage());
		act.setIsActive(new Integer(1));

		//save the file
		try{
			Util.storeFile(otd.getFile(), act.getPhoto());
		} catch (IOException ioEx){
			return actionMapping
			.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
		} catch (ExistingFileException efEx){
			return actionMapping
			.findForward(SystemConstants.FORWARD_EXISTING_FILE);
		}

		Facade.getInstance().registerActivity(act, new ArrayList(),
				otd.getCollSchedule());

		form.limparOtd(request);
		form.setName("");
		form.setDescription("");
		form.setValue("0,00");
		
		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);

	}

	private ActivityRegisterOTD setOtd(HttpServletRequest request,
			ActivityRegisterActionForm form) {
		ActivityRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof ActivityRegisterOTD)) {
			otd = new ActivityRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (ActivityRegisterOTD) form.getOtd(request);
		}
		return otd;
	}

}
