package com.efetiva.wiiser.webserver.gui.activity;

import java.util.Collection;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiiser.server.entity.ScheduleActivity;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ActivityScheduleAction extends ObjectAction {

	public static String USER_CASE = ActivityScheduleAction.class
			.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityScheduleActionForm form = (ActivityScheduleActionForm) requestActionForm;
		form.setDayOfWeek("Todos");
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
		
	}

	public ActionForward exhibitIFrame(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityScheduleActionForm form = (ActivityScheduleActionForm) requestActionForm;

		int activityId = -1;
		try {
			activityId = Integer.parseInt(request.getParameter("activityId"));
			request.getSession().setAttribute("activityId", activityId);
		} catch (NumberFormatException e) {
			activityId = (Integer) request.getSession().getAttribute(
					"activityId");
		}

		Collection coll = Facade.getInstance().searchScheduleByActivity(
				activityId);
		form.setCollSchedules(coll);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_ACTIVITY_IFRAME);

	}
	

	public ActionForward add(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ActivityScheduleActionForm form = (ActivityScheduleActionForm) requestActionForm;

		int activityId = (Integer) request.getSession().getAttribute("activityId");
		Activity activity = Facade.getInstance().searchActivity(activityId);

		String day = form.getDayOfWeek();
		Integer dayOfWeek = null;
		if (day.equals("Domingo")) {
			dayOfWeek = new Integer(0);
		} else if (day.equals("Segunda-feira")) {
			dayOfWeek = new Integer(1);
		} else if (day.equals("Tera-feira")) {
			dayOfWeek = new Integer(2);
		} else if (day.equals("Quarta-feira")) {
			dayOfWeek = new Integer(3);
		} else if (day.equals("Quinta-feira")) {
			dayOfWeek = new Integer(4);
		} else if (day.equals("Sexta-feira")) {
			dayOfWeek = new Integer(5);
		} else if (day.equals("Sbado")) {
			dayOfWeek = new Integer(6);
		} else {
			dayOfWeek = new Integer(7);
		}
		
		int hours = Integer.parseInt(form.getHours());
		int minutes = Integer.parseInt(form.getMinutes());
		Date date = new Date();
		date.setHours(hours);
		date.setMinutes(minutes);
		
		
		if(dayOfWeek != 7){
			ScheduleActivity schedule = new ScheduleActivity(activity, dayOfWeek, date);
			Facade.getInstance().registerScheduleActivity(schedule);
		} else{
			for (int i = 0; i < 7; i++) {
				ScheduleActivity schedule = new ScheduleActivity(activity, i, date);
				Facade.getInstance().registerScheduleActivity(schedule);
			}
		}
		

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward remove(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		int id = Integer.parseInt(request.getParameter("scheduleId"));
		ScheduleActivity schedule = Facade.getInstance()
				.searchScheduleActivity(id);
		if (schedule != null) {
			Facade.getInstance().removeScheduleActivity(schedule);
		}
		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}
}
