package com.efetiva.wiiser.webserver.gui.language;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class LanguageModifyAction extends ObjectAction {

	public static String USER_CASE = LanguageModifyAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		LanguageModifyActionForm form = (LanguageModifyActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		Integer id = Integer.parseInt(request.getParameter("languageId"));
		request.getSession().setAttribute("idLanguage", id);

		Language language = Facade.getInstance().searchLanguage(id);

		form.setName(language.getName());
		form.setAcronym(language.getAcronym());
		
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
			
	}

	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		LanguageModifyActionForm form = (LanguageModifyActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

			/*Integer id = (Integer) request.getSession().getAttribute("idLanguage");
			String name = form.getName();
			String acronym = form.getAcronym();
			FormFile file = form.getFile();

			Language language = Facade.getInstance().searchLanguage(id);
			if (language != null) {
				language.setName(name);
				language.setAcronym(acronym);
				language.setFilePath(SystemConstants.LANGUAGE_FILES_FOLDER + file.getFileName());
				
				Facade.getInstance().modifyLanguage(language);

				return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
			} else {
				return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
			}*/
			
			LanguageModifyActionForm form = (LanguageModifyActionForm) requestActionForm;

			String acronym = form.getAcronym();
			String name = form.getName();
			FormFile file = form.getFile();
			Integer id = (Integer) request.getSession().getAttribute("idLanguage");
			
			// Lembra de implementar o searchLanguage por nome

			if (!acronym.trim().equals("")) {
				if (!name.trim().equals("")) {
					Language l = null; 
					l = Facade.getInstance().searchLanguageByName(name);
					Language language = Facade.getInstance().searchLanguage(id);
					if ((l == null) || (l.getId() != language.getId())) {
						if (language != null) {
							language.setName(name);
							language.setAcronym(acronym);
							//ajustar este caminho
							String path = SystemConstants.LANGUAGE_FILES_FOLDER;
							String fileToSavePath =  path + 
								name + "-" + acronym + ".properties";
							String fileName = file.getFileName();
							if (!fileName.trim().equals("")) {
								if(fileName.contains(".properties")){
									Util.deleteFile(language.getFilePath());
									language.setFilePath(fileToSavePath);
									try{
										Util.storeFile(file.getFileData(), fileToSavePath);
									} catch (IOException ioEx){
										return actionMapping
										.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
									}
								} else {
									return actionMapping
									.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
								}
							} else {
								Util.renameFile(language.getFilePath(), fileToSavePath);
								language.setFilePath(fileToSavePath);
							}
							Facade.getInstance().modifyLanguage(language);
						} else {
							return actionMapping
							.findForward(SystemConstants.FORWARD_SERVER_ERROR);
						}
					} else {
						return actionMapping
								.findForward(SystemConstants.FORWARD_LANGUAGE_EXIST);
					}
				} else {
					return actionMapping
							.findForward(SystemConstants.FORWARD_WRONG_LANGUAGE);
				}
			} else {
				return actionMapping
				.findForward(SystemConstants.FORWARD_EMPTY_ACRONYM_FIELD);
			}
				
			form.setAcronym("");
			form.setName("");
			form.setFile(null);
			return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
			
	}	

}
