package com.efetiva.wiiser.webserver.gui.language;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.exception.ExistingFileException;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class LanguageRegisterAction extends ObjectAction {
	public static String USER_CASE = LanguageRegisterAction.class
			.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		return actionMapping
			.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		LanguageRegisterActionForm form = (LanguageRegisterActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		LanguageRegisterActionForm form = (LanguageRegisterActionForm) requestActionForm;

		String acronym = form.getAcronym();
		String name = form.getName();
		FormFile file = form.getFile();
		
		
		// Lembra de implementar o searchLanguage por nome

		if (!acronym.trim().equals("")) {
			if (!name.trim().equals("")) {
				Language l = null;
				l = Facade.getInstance().searchLanguageByName(name);
				if (l == null) {
					//ajustar este caminho
					String path = SystemConstants.LANGUAGE_FILES_FOLDER;
					String fileToSavePath =  path + 
						name + "-" + acronym + ".properties";
					String fileName = file.getFileName();
					if (!fileName.trim().equals("")) {
						if(fileName.contains(".properties")){
							Language language = new Language();
							language.setName(name);
							language.setAcronym(acronym);
							language.setFilePath(fileToSavePath);
							try{
								Util.storeFile(file.getFileData(), fileToSavePath);
							} catch (IOException ioEx){
								return actionMapping
								.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
							} catch (ExistingFileException efEx){
								return actionMapping
								.findForward(SystemConstants.FORWARD_EXISTING_FILE);
							}
							try{
								Facade.getInstance().registerLanguage(language);
							} catch (Exception e){
								Util.deleteFile(fileToSavePath);
							}
						} else {
							return actionMapping
							.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
						}
					} else {
						return actionMapping
						.findForward(SystemConstants.FORWARD_EMPTY_FILE_FIELD);
					}
				} else {
					return actionMapping
							.findForward(SystemConstants.FORWARD_LANGUAGE_EXIST);
				}
			} else {
				return actionMapping
						.findForward(SystemConstants.FORWARD_WRONG_LANGUAGE);
			}
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_EMPTY_ACRONYM_FIELD);
		}
			
		form.setAcronym("");
		form.setName("");
		form.setFile(null);
		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
			
	}
	
	
}
