package com.efetiva.wiiser.webserver.gui.language;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class LanguageRemoveAction extends ObjectAction{

	public static String USER_CASE = LanguageRemoveAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		String languageId = request.getParameter("languageId");
		
		/* Verifica se existem atividades com esse idioma */
		Collection activityByLanguage = Facade.getInstance().searchActivitiesByLanguage(Integer.parseInt(languageId));
		if(!activityByLanguage.isEmpty()){
			request.getSession().setAttribute("messageError", "Existem atividades com esse idioma. Remova-as primeiro.");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		/* Verifica se existem servios com esse idioma */
		Collection serviceByLanguage = Facade.getInstance().searchServicesByLanguage(Integer.parseInt(languageId));
		if(!serviceByLanguage.isEmpty()){
			request.getSession().setAttribute("messageError", "Existem servios com esse idioma. Remova-os primeiro.");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		/* Verifica se existem mensagem dynamicas com esse idioma */
		Collection infoByLanguage = Facade.getInstance().searchDynamicInfoByLanguage(Integer.parseInt(languageId));
		if(!infoByLanguage.isEmpty()){
			request.getSession().setAttribute("messageError", "Existem mensagens com esse idioma. Remova-as primeiro.");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		/* Verifica se existem sub-areas com esse idioma */
		Collection placeByLanguage = Facade.getInstance().searchPlacesByLanguage(Integer.parseInt(languageId));
		if(!placeByLanguage.isEmpty()){
			request.getSession().setAttribute("messageError", "Existem sub-reas com esse idioma. Remova-os primeiro.");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		
		Language language = Facade.getInstance().searchLanguage(Integer.parseInt(languageId));
		if (language != null) {
			Util.deleteFile(language.getFilePath());
			Facade.getInstance().removeLanguage(language);
		}
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
		
	}
}
