package com.efetiva.wiiser.webserver.gui.message;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.Area;
import com.efetiva.wiiser.server.entity.DynamicInfo;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.ScheduleInfo;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class MessageChangeAction extends ObjectAction {

	public static String USER_CASE = MessageChangeAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MessageChangeActionForm form = (MessageChangeActionForm) requestActionForm;

		Integer messageId = new Integer(request.getParameter("messageId"));

		DynamicInfo di = new DynamicInfo();
		if (messageId != null) {
			di = Facade.getInstance().searchDynamicInfo(messageId);
		}
		form.setDescription(di.getDescription());
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		form.setLanguage(di.getLanguage().getId().toString());

		Collection coll = Facade.getInstance().searchScheduleInfoByDynamicInfo(
				di.getId());

		if (coll != null && !coll.isEmpty()) {
			ScheduleInfo si = null;
			Iterator it = coll.iterator();
			while (it.hasNext()) {
				si = (ScheduleInfo) it.next();
				break;
			}

			Integer areaId = si.getArea().getId();
			if (areaId.equals(-6316129)) {
				form.setArea("Ala Marlin");
			} else if (areaId.equals(-65536)) {
				form.setArea("Piscinas");
			} else if (areaId.equals(-16776961)) {
				form.setArea("Ala Dourado");
			} else if (areaId.equals(-16711681)) {
				form.setArea("Bangalos Caracois");
			} else if (areaId.equals(-65281)) {
				form.setArea("Praia");
			} else if (areaId.equals(-16711936)) {
				form.setArea("Bangalos Buzios");
			} else if (areaId.equals(-16777216)) {
				form.setArea("Complexo Esportivo");
			} else if (areaId.equals(-66047)) {
				form.setArea("Ala Estrela");
			} else {
				form.setArea("Estacionamento");
			}

			Integer week = si.getDayOfWeek();
			String diaSemana = null;
			if (week.equals(1)) {
				diaSemana = "Segunda-feira";
			} else if (week.equals(2)) {
				diaSemana = "Tera-feira";
			} else if (week.equals(3)) {
				diaSemana = "Quarta-feira";
			} else if (week.equals(4)) {
				diaSemana = "Quinta-feira";
			} else if (week.equals(5)) {
				diaSemana = "Sexta-feira";
			} else if (week.equals(6)) {
				diaSemana = "Sbado";
			} else {
				diaSemana = "Domingo";
			}
			
			if(coll.size() > 1) {
				form.setWeekday("Todos");
			} else {
				form.setWeekday(diaSemana);
			}

			char time[] = si.getHour().toCharArray();
			String hora = "" + time[0] + time[1];
			String minuto = "" + time[2] + time[3];
			form.setHora(hora);
			form.setMinuto(minuto);
		}
		form.setDynamicInfo(di);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MessageChangeActionForm form = (MessageChangeActionForm) requestActionForm;

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MessageChangeActionForm form = (MessageChangeActionForm) requestActionForm;

		DynamicInfo di = new DynamicInfo();
		di.setId(form.getDynamicInfo().getId());
		di.setDescription(form.getDescription());
		Language l = Facade.getInstance().searchLanguage(
				new Integer(form.getLanguage()));
		di.setLanguage(l);

		Integer areaId = null;
		if (form.getArea().equalsIgnoreCase("Ala Martin")) {
			areaId = new Integer(-6316129);
		} else if (form.getArea().equalsIgnoreCase("Piscinas")) {
			areaId = new Integer(-65536);
		} else if (form.getArea().equalsIgnoreCase("Ala Dourado")) {
			areaId = new Integer(-16776961);
		} else if (form.getArea().equalsIgnoreCase("Bangalos Caracois")) {
			areaId = new Integer(-16711681);
		} else if (form.getArea().equalsIgnoreCase("Praia")) {
			areaId = new Integer(-65281);
		} else if (form.getArea().equalsIgnoreCase("Bangalos Buzios")) {
			areaId = new Integer(-16711936);
		} else if (form.getArea().equalsIgnoreCase("Complexo Esportivo")) {
			areaId = new Integer(-16777216);
		} else if (form.getArea().equalsIgnoreCase("Ala Estrela")) {
			areaId = new Integer(-66047);
		} else {
			areaId = new Integer(-1);
		}
		
		String week = form.getWeekday().trim();
		Integer diaSemana = null;
		if (week.equalsIgnoreCase("Segunda-Feira")) {
			diaSemana = new Integer(1);
		} else if (week.equalsIgnoreCase("Tera-Feira")) {
			diaSemana = new Integer(2);
		} else if (week.equalsIgnoreCase("Quarta-Feira")) {
			diaSemana = new Integer(3);
		} else if (week.equalsIgnoreCase("Quinta-Feira")) {
			diaSemana = new Integer(4);
		} else if (week.equalsIgnoreCase("Sexta-Feira")) {
			diaSemana = new Integer(5);
		} else if (week.equalsIgnoreCase("Sbado")) {
			diaSemana = new Integer(6);
		} else if (week.equalsIgnoreCase("Domingo")) {
			diaSemana = new Integer(0);
		} else {
			diaSemana = new Integer(7);
		}

		String hora = (form.getHora().trim() + form.getMinuto().trim());

		Area a = Facade.getInstance().searchArea(areaId);
		Collection coll = (Collection) Facade.getInstance()
				.searchScheduleInfoByDynamicInfo(di.getId());

		if (di == null) {
			return actionMapping.findForward("errorMessage");
		}

		Facade.getInstance().modifyDynamicInfo(di, new ArrayList());
		
		Iterator it = coll.iterator();
		while (it.hasNext()) {
			ScheduleInfo si = (ScheduleInfo) it.next();
			Facade.getInstance().removeScheduleInfo(si);;
		}

		if (diaSemana != 7){
			ScheduleInfo si = new ScheduleInfo();
			si.setArea(a);
			si.setDayOfWeek(diaSemana);
			si.setDynamicInfo(di);
			si.setHour(hora);

			Facade.getInstance().registerScheduleInfo(si);
		} else {
			for (int i = 0; i < 7; i++) {
				ScheduleInfo si = new ScheduleInfo();
				si.setArea(a);
				si.setDayOfWeek(i);
				si.setDynamicInfo(di);
				si.setHour(hora);
				
				Facade.getInstance().registerScheduleInfo(si);
			}
		}

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);

	}
}
