package com.efetiva.wiiser.webserver.gui.message;

import java.util.ArrayList;
import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.Area;
import com.efetiva.wiiser.server.entity.DynamicInfo;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.ScheduleInfo;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class MessageRegisterAction extends ObjectAction {

	public static String USER_CASE = MessageRegisterAction.class
			.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MessageRegisterActionForm form = (MessageRegisterActionForm) requestActionForm;

		form.setDescription("");

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		if (collLanguage.isEmpty()) {
			request
					.getSession()
					.setAttribute("messageError",
							"Para incluir uma mensagem  preciso ter cadastrado pelo menos um idioma");
			return actionMapping
					.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		form.setCollLanguage(collLanguage);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MessageRegisterActionForm form = (MessageRegisterActionForm) requestActionForm;

		DynamicInfo msg = new DynamicInfo();
		msg.setDescription(form.getMessage());
		Language l = Facade.getInstance().searchLanguage(
				new Integer(form.getLanguage()));
		msg.setLanguage(l);

		Integer areaId = null;
		if (form.getArea().equalsIgnoreCase("Ala Martin")) {
			areaId = new Integer(-6316129);
		} else if (form.getArea().equalsIgnoreCase("Piscinas")) {
			areaId = new Integer(-65536);
		} else if (form.getArea().equalsIgnoreCase("Ala Dourado")) {
			areaId = new Integer(-16776961);
		} else if (form.getArea().equalsIgnoreCase("Bangalos Caracois")) {
			areaId = new Integer(-16711681);
		} else if (form.getArea().equalsIgnoreCase("Praia")) {
			areaId = new Integer(-65281);
		} else if (form.getArea().equalsIgnoreCase("Bangalos Buzios")) {
			areaId = new Integer(-16711936);
		} else if (form.getArea().equalsIgnoreCase("Complexo Esportivo")) {
			areaId = new Integer(-16777216);
		} else if (form.getArea().equalsIgnoreCase("Ala Estrela")) {
			areaId = new Integer(-66047);
		} else {
			areaId = new Integer(-1);
		}

		Area a = Facade.getInstance().searchArea(areaId);

		Facade.getInstance().registerDynamicInfo(msg, new ArrayList());

		DynamicInfo d = (DynamicInfo) Facade.getInstance().selectMaxId();

		String week = form.getWeekday().trim();
		Integer diaSemana = null;
		if (week.equalsIgnoreCase("Segunda-Feira")) {
			diaSemana = new Integer(1);
		} else if (week.equalsIgnoreCase("Tera-Feira")) {
			diaSemana = new Integer(2);
		} else if (week.equalsIgnoreCase("Quarta-Feira")) {
			diaSemana = new Integer(3);
		} else if (week.equalsIgnoreCase("Quinta-Feira")) {
			diaSemana = new Integer(4);
		} else if (week.equalsIgnoreCase("Sexta-Feira")) {
			diaSemana = new Integer(5);
		} else if (week.equalsIgnoreCase("Sbado")) {
			diaSemana = new Integer(6);
		} else if (week.equalsIgnoreCase("Domingo")) {
			diaSemana = new Integer(0);
		} else {
			diaSemana = new Integer(7);
		}

		String hora = form.getHora() + form.getMinuto();
		
		if (diaSemana != 7){
			ScheduleInfo si = new ScheduleInfo();
			si.setArea(a);
			si.setDayOfWeek(diaSemana);
			si.setDynamicInfo(d);
			si.setHour(hora);

			Facade.getInstance().registerScheduleInfo(si);
		} else {
			for (int i = 0; i < 7; i++) {
				ScheduleInfo si = new ScheduleInfo();
				si.setArea(a);
				si.setDayOfWeek(i);
				si.setDynamicInfo(d);
				si.setHour(hora);
				
				Facade.getInstance().registerScheduleInfo(si);
			}
		}
		
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		form.setMessage("");
		form.setWeekday("Todos");
		form.setHora("00");
		form.setMinuto("00");

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);

	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MessageRegisterActionForm form = (MessageRegisterActionForm) requestActionForm;

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}
}