package com.efetiva.wiiser.webserver.gui.service;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.Functions;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ServiceModifyAction extends ObjectAction {

	public static String USER_CASE = ServiceModifyAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		ServiceModifyActionForm form = (ServiceModifyActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);
		
		Integer id = Integer.parseInt(request.getParameter("serviceId"));
		request.getSession().setAttribute("idService", id);
		
		Service service = Facade.getInstance().searchService(id);
		
		form.setName(service.getName());
		form.setDescription(service.getDescription());
		form.setValue(""+service.getValue().doubleValue());
		form.setIsActive(service.getIsActive().toString());
		
		Collection allLanguages = Facade.getInstance().searchAllLanguages();
		
		form.setCollLanguage(allLanguages);
		form.setLanguage(service.getLanguage().getId().toString());
		
		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(service.getLanguage().getId());
		
		form.setCollPlace(collPlaces);
		form.setPlace(service.getPlace().getId().toString());
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}
	
	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceModifyActionForm form = (ServiceModifyActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceModifyActionForm form = (ServiceModifyActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		Integer id = (Integer) request.getSession().getAttribute("idService");
		request.getSession().removeAttribute("idService");
		String name = form.getName();
		String description = form.getDescription();
		FormFile file = form.getPhoto();
		String namePlace = form.getPlace();
		String value = form.getValue();
		
		if(value.equals("")){
			form.setValue("0,00");
			value = "0,00";
		}
		
		Integer codigo = null;
		if (!"".equals(form.getLanguage())) {
			codigo = new Integer(form.getLanguage());
		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Collection collPlaces = Facade.getInstance()
				.searchPlacesByLanguage(codigo);
		form.setCollPlace(collPlaces);
		
		if(collPlaces.isEmpty()){
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_SELECTED);
		}
		
		if(name.trim().equals("")){
			return actionMapping
				.findForward(SystemConstants.FORWARD_EMPTY_NAME);
		}
		
		if(description.trim().equals("")){
			return actionMapping
				.findForward(SystemConstants.FORWARD_EMPTY_DESCRIPTION);
		}
		
		Integer languageId = new Integer(form.getLanguage());
		Service s = Facade.getInstance().searchServiceByName(name, languageId);
		if((s != null) && (s.getId().intValue() != id.intValue())){
			return actionMapping
				.findForward(SystemConstants.FORWARD_EXISTING_SERVICE_NAME);
		}
		
		Language language = Facade.getInstance().searchLanguage(
				languageId);
		Place place = Facade.getInstance().searchPlace(
				new Integer(namePlace));

		Service service = Facade.getInstance().searchService(id);
		if (service != null) {
			service.setName(name);
			service.setDescription(description);
			service.setValue(Functions.parseDouble(value));
			service.setLanguage(language);
			service.setPlace(place);
			if (form.getIsActive().equals("1")) {
				service.setIsActive(new Integer(1));
			} else {
				service.setIsActive(new Integer(0));
			}
			Collection schedules = service.getSchedules();

			String fileToSavePath =  SystemConstants.SERVICE_IMAGES_FOLDER + 
				name + "-" + language.getName();
			String fileName = file.getFileName();
			if (!fileName.trim().equals("")) {
				String fileType = file.getContentType(); 
				if(fileType.equals("image/x-png")) {
					fileToSavePath += ".png";
				} else if (fileType.equals("image/jpg")) {
					fileToSavePath += ".jpg";
				} else if (fileType.equals("image/jpeg")){
					fileToSavePath += ".jpeg";
				} else if (fileType.equals("image/gif")){
					fileToSavePath += ".gif";
				} else {
					return actionMapping
					.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
				}
				
				Util.deleteFile(service.getPhoto());
				service.setPhoto(fileToSavePath);
				try{
					Util.storeFile(file.getFileData(), fileToSavePath);
				} catch (IOException ioEx){
					return actionMapping
					.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
				}
			} else {
				String fileType = service.getPhoto();
				
				if(fileType.contains(".png")) {
					fileToSavePath += ".png";
				} else if (fileType.contains(".jpg")) {
					fileToSavePath += ".jpg";
				} else if (fileType.contains(".jpeg")){
					fileToSavePath += ".jpeg";
				} else if (fileType.contains(".gif")){
					fileToSavePath += ".gif";
				}
				
				Util.renameFile(service.getPhoto(), fileToSavePath);
				service.setPhoto(fileToSavePath);
			}
			
			Facade.getInstance().modifyService(service, new ArrayList(),
					schedules);

			return actionMapping
					.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
		} else {
			return actionMapping
					.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceModifyActionForm form = (ServiceModifyActionForm) requestActionForm;

		Integer codigo = null;
		if (!"".equals(form.getLanguage())) {
			codigo = new Integer(form.getLanguage());

		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Collection collPlaces = Facade.getInstance()
				.searchPlacesByLanguage(codigo);
		form.setCollPlace(collPlaces);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}
}
