package com.efetiva.wiiser.webserver.gui.service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.ScheduleService;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.exception.ExistingFileException;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.Functions;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ServiceRegisterAction extends ObjectAction {

	public static String USER_CASE = ServiceRegisterAction.class
			.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;
		ServiceRegisterOTD otd = getOTD(request, form);

		form.setName("");
		form.setDescription("");
		form.setValue("0,00");
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		
		if(collLanguage.isEmpty()){
			request.getSession().setAttribute("messageError", "Para incluir um servio  preciso ter cadastrado pelo menos um idioma");
			return actionMapping
			.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		form.setCollLanguage(collLanguage);
		Language l = null;
		if (collLanguage != null) {
			Iterator it = collLanguage.iterator();
			while (it.hasNext()) {
				l = (Language) it.next();
				break;
			}

		}
		
		otd.setLanguage(l);

		Collection collPlaces = Facade.getInstance().searchAllPlaces();
		if(collPlaces.isEmpty()){
			request.getSession().setAttribute("messageError", "Para incluir um servio  preciso ter cadastrado pelo menos uma sub-rea");
			return actionMapping
			.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		Collection collPlacesByLanguage = Facade.getInstance().searchPlacesByLanguage(l.getId());
		form.setCollPlace(collPlacesByLanguage);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	private ServiceRegisterOTD getOTD(HttpServletRequest request, ServiceRegisterActionForm form) {
		ServiceRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof ServiceRegisterOTD)) {
			otd = new ServiceRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (ServiceRegisterOTD) form.getOtd(request);
		}
		return otd;
	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;
		
		ServiceRegisterOTD otd = getOTD(request, form);

		Service serv = new Service();
		serv.setDescription(form.getDescription());
		serv.setIsActive(new Integer(1));
		Language l = otd.getLanguage();
		serv.setLanguage(l);
		serv.setName(form.getName());
		
		String valueString = form.getValue();
		Double valor = 0.00;
		if(!valueString.equals("")){
			valor = Functions.parseDouble(valueString);
		}
		serv.setValue(valor);

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(
				otd.getLanguage().getId());
		form.setCollPlace(collPlaces);
		if(!valueString.equals("")){
			form.setValue(valueString);
		} else {
			form.setValue("0,00");
		}
		
		if(collPlaces.isEmpty()){
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_SELECTED);
		}
		
		Service s = null;
		s = Facade.getInstance().searchServiceByName(serv.getName(), serv.getLanguage().getId());
		if (s != null) {
			return actionMapping.findForward("existService");
		}
		
		//file handle
		FormFile file = form.getPhoto();
		if (file.getFileName().trim().equals("")) {
			return actionMapping
			.findForward(SystemConstants.FORWARD_EMPTY_FILE_FIELD);
		}
		String fileToSavePath = SystemConstants.SERVICE_IMAGES_FOLDER + 
			serv.getName() + "-" + serv.getLanguage().getName();
		String fileType = file.getContentType(); 
		if(fileType.equals("image/x-png")) {
			fileToSavePath += ".png";
		} else if (fileType.equals("image/jpg")) {
			fileToSavePath += ".jpg";
		} else if (fileType.equals("image/jpeg")){
			fileToSavePath += ".jpeg";
		} else if (fileType.equals("image/gif")){
			fileToSavePath += ".gif";
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
		}
		
		serv.setPhoto(fileToSavePath);
		otd.setFile(file.getFileData());
		
		Place p = Facade.getInstance()
				.searchPlace(new Integer(form.getPlace()));
		serv.setPlace(p);

		otd.setService(serv);

		Collection collSchedule = Facade.getInstance().searchScheduleByService(
				serv.getId());
		if (collSchedule != null) {
			otd.setCollSchedule(collSchedule);
		}
		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE);

	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;

		ServiceRegisterOTD otd = getOTD(request, form);

		Integer cod = null;
		if (!"".equals(form.getLanguage())) {
			cod = new Integer(form.getLanguage());

		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = Facade.getInstance().searchLanguage(
				new Integer(form.getLanguage()));
		otd.setLanguage(l);
		Collection collPlaces = Facade.getInstance()
				.searchPlacesByLanguage(cod);
		form.setCollPlace(collPlaces);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward schedule(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;

		ServiceRegisterOTD otd = getOTD(request, form);
		
		form.setWeekday("Todos");
		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE_JSP);

	}

	public ActionForward scheduleIFrame(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;

		ServiceRegisterOTD otd = getOTD(request, form);
		return actionMapping
				.findForward(SystemConstants.FORWARD_SCHEDULE_JSP_FRAME);

	}

	public ActionForward scheduleAdd(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;

		ServiceRegisterOTD otd = getOTD(request, form);

		String week = form.getWeekday().trim();
		Integer diaSemana = null;
		if (week.equalsIgnoreCase("Segunda-Feira")) {
			diaSemana = new Integer(1);
		} else if (week.equalsIgnoreCase("Tera-Feira")) {
			diaSemana = new Integer(2);
		} else if (week.equalsIgnoreCase("Quarta-Feira")) {
			diaSemana = new Integer(3);
		} else if (week.equalsIgnoreCase("Quinta-Feira")) {
			diaSemana = new Integer(4);
		} else if (week.equalsIgnoreCase("Sexta-Feira")) {
			diaSemana = new Integer(5);
		} else if (week.equalsIgnoreCase("Sbado")) {
			diaSemana = new Integer(6);
		} else if (week.equals("Domingo")) {
			diaSemana = new Integer(0);
		} else {
			diaSemana = new Integer(7);
		}

		Date dataInicial = new Date();
		dataInicial.setHours(Integer.parseInt(form.getHoraInicial().trim()));
		dataInicial.setMinutes(Integer.parseInt(form.getMinutoFinal().trim()));

		Date dataFinal = new Date();
		dataFinal.setHours(Integer.parseInt(form.getHoraFinal().trim()));
		dataFinal.setMinutes(Integer.parseInt(form.getMinutoFinal().trim()));

		if(diaSemana != 7){
			ScheduleService ss = new ScheduleService();
			ss.setService(otd.getService());
			ss.setDayOfWeek(diaSemana);
			ss.setHourInitial(dataInicial);
			ss.setHourFinal(dataFinal);
			otd.addScheduleService(ss);
		} else{
			for(int i=0; i<7; i++){
				ScheduleService ss = new ScheduleService();
				ss.setService(otd.getService());
				ss.setDayOfWeek(i);
				ss.setHourInitial(dataInicial);
				ss.setHourFinal(dataFinal);
				otd.addScheduleService(ss);
			}
		}
		
		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE);

	}

	public ActionForward scheduleRemove(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;

		ServiceRegisterOTD otd = getOTD(request, form);

		Integer posicao = new Integer(form.getPrymaryKey());
		otd.removeScheduleService(posicao);

		return actionMapping.findForward(SystemConstants.FORWARD_SCHEDULE);
	}

	public ActionForward finish(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceRegisterActionForm form = (ServiceRegisterActionForm) requestActionForm;

		ServiceRegisterOTD otd = getOTD(request, form);

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = null;
		if (collLanguage != null) {
			Iterator it = collLanguage.iterator();
			while (it.hasNext()) {
				l = (Language) it.next();
				break;
			}

		}
		Collection collPlaces = Facade.getInstance().searchPlacesByLanguage(
				l.getId());
		form.setCollPlace(collPlaces);

		Service serv = otd.getService();
		serv.setSchedules(otd.getCollSchedule());
		serv.setLanguage(otd.getLanguage());
		serv.setIsActive(new Integer(1));

		//save the file
		try{
			Util.storeFile(otd.getFile(), serv.getPhoto());
		} catch (IOException ioEx){
			return actionMapping
			.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
		} catch (ExistingFileException efEx){
			return actionMapping
			.findForward(SystemConstants.FORWARD_EXISTING_FILE);
		}
	
		Facade.getInstance().registerService(serv, new ArrayList(),
				otd.getCollSchedule());

		form.limparOtd(request);
		form.setName("");
		form.setDescription("");
		form.setValue("0,00");

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);

	}

}
