package com.efetiva.wiiser.webserver.gui.service;

import java.util.Collection;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.ScheduleService;
import com.efetiva.wiiser.server.entity.Service;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ServiceScheduleAction extends ObjectAction {

	public static String USER_CASE = ServiceScheduleAction.class.getSimpleName()
										+ SystemConstants.USER_CASE_EXTENSION;
	
	
	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceScheduleActionForm form = (ServiceScheduleActionForm) requestActionForm;
		form.setDayOfWeek("Todos");
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
		

	}
	
	public ActionForward exhibitIFrame(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		ServiceScheduleActionForm form = (ServiceScheduleActionForm) requestActionForm;
		
		int serviceId = -1;
		try {
			serviceId = Integer.parseInt(request.getParameter("serviceId"));
			request.getSession().setAttribute("serviceId", serviceId);
		} catch (NumberFormatException e) {
			serviceId = (Integer) request.getSession().getAttribute("serviceId");
		}

		Collection coll = Facade.getInstance().searchScheduleByService(serviceId);
		form.setCollSchedules(coll);

		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_ACTIVITY_IFRAME);
	}
	
	public ActionForward add(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceScheduleActionForm form = (ServiceScheduleActionForm) requestActionForm;

		int serviceId = (Integer) request.getSession().getAttribute("serviceId");
		Service service = Facade.getInstance().searchService(serviceId);

		String day = form.getDayOfWeek();
		Integer dayOfWeek = null;
		if (day.equals("Domingo")) {
			dayOfWeek = new Integer(0);
		} else if (day.equals("Segunda-feira")) {
			dayOfWeek = new Integer(1);
		} else if (day.equals("Tera-feira")) {
			dayOfWeek = new Integer(2);
		} else if (day.equals("Quarta-feira")) {
			dayOfWeek = new Integer(3);
		} else if (day.equals("Quinta-feira")) {
			dayOfWeek = new Integer(4);
		} else if (day.equals("Sexta-feira")) {
			dayOfWeek = new Integer(5);
		} else if (day.equals("Sbado")) {
			dayOfWeek = new Integer(6);
		} else{
			dayOfWeek = new Integer(7);
		}

		int initialHours = Integer.parseInt(form.getInitialHours());
		int initialMinutes = Integer.parseInt(form.getInitialMinutes());
		int finalHours = Integer.parseInt(form.getFinalHours());
		int finalMinutes = Integer.parseInt(form.getFinalMinutes());
		
		Date initialDate = new Date();
		initialDate.setHours(initialHours);
		initialDate.setMinutes(initialMinutes);
		
		Date finalDate = new Date();
		finalDate.setHours(finalHours);
		finalDate.setMinutes(finalMinutes);
		
		
		if(dayOfWeek != 7){
			ScheduleService schedule = new ScheduleService(service, dayOfWeek,	initialDate, finalDate);
			Facade.getInstance().registerScheduleService(schedule);
		} else{
			for (int i = 0; i<7; i++) {
				ScheduleService schedule = new ScheduleService(service, i,	initialDate, finalDate);
				Facade.getInstance().registerScheduleService(schedule);
			}
		}
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}
	
	public ActionForward remove(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		int id = Integer.parseInt(request.getParameter("scheduleId"));
		ScheduleService schedule = Facade.getInstance().searchScheduleService(id);
		if (schedule != null) {
			Facade.getInstance().removeScheduleService(schedule);
		}
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}
	
}
