package com.efetiva.wiiser.webserver.gui.service;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class ServiceSearchAction extends ObjectAction {

	public static String USER_CASE = ServiceSearchAction.class.getSimpleName()
										+ SystemConstants.USER_CASE_EXTENSION;
	
	public ActionForward exhibitIFrame(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		ServiceSearchActionForm form = (ServiceSearchActionForm) requestActionForm;

		Collection coll = Facade.getInstance().searchAllServices();
		form.setCollService(coll);

		int i = coll.size();
		if (i == 0) {
			form.setNumero("Nenhum servio foi encontrado!!");
		} else if (i == 1) {
			form.setNumero("1 servio foi encontrado!!");
		} else {
			form.setNumero(i + " servios foram encontrados!!");
		}
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SERVICE_IFRAME);
	}
	
	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		return setDoAction(actionMapping, requestActionForm);
	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		return setDoAction(actionMapping, requestActionForm);

	}

	private ActionForward setDoAction(ActionMapping actionMapping,
			ActionForm requestActionForm) {
		ServiceSearchActionForm form = (ServiceSearchActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);
		
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}
}
