package com.efetiva.wiiser.webserver.gui.subarea;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Area;
import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.CategoryPlace;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.PlaceArea;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.exception.ExistingFileException;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.Functions;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class SubAreaChangeAction extends ObjectAction {

	public static String USER_CASE = SubAreaChangeAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		Integer placeId = new Integer(request.getParameter("placeId").trim());
		Place place = Facade.getInstance().searchPlace(placeId);

		form.setName(place.getName());
		form.setDescription(place.getDescription());

		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		form.setLanguage(place.getLanguage().getId().toString());

		if (collLanguage.isEmpty()) {
			request
					.getSession()
					.setAttribute("messageError",
							"Para incluir uma sub-rea  preciso ter cadastrado pelo menos um idioma");
			return actionMapping
					.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}

		Collection collCategoryPlace = Facade.getInstance()
				.searchCategoryPlaceByPlace(placeId);
		Iterator it1 = collCategoryPlace.iterator();
		CategoryPlace categoryPlace = null;
		while (it1.hasNext()) {
			categoryPlace = (CategoryPlace) it1.next();
			break;
		}
		Integer categoryId = categoryPlace.getCategory().getId();

		if (categoryId.equals(1)) {
			form.setCategory("Esporte e Lazer");
		} else if (categoryId.equals(2)) {
			form.setCategory("Restaurantes");
		} else if (categoryId.equals(3)) {
			form.setCategory("Acomodaes");
		} else {
			form.setCategory("Outros");
		}

		Collection collAreas = Facade.getInstance().searchAllAreas();
		if (collAreas.isEmpty()) {
			request.getSession().setAttribute("messageError",
					"Nenhuma rea encontrada. Contate o administrador.");
			return actionMapping
					.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}

		Language l = null;
		if (collLanguage != null) {
			Iterator it = collLanguage.iterator();
			while (it.hasNext()) {
				l = (Language) it.next();
				break;
			}
		}
		otd.setLanguage(l);
		otd.setPlace(place);
		otd.setCollPlaceArea(Facade.getInstance().searchPlaceAreasByPlace(
				placeId));

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		Place place = otd.getPlace();
		place.setDescription(form.getDescription());
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		Language l = Facade.getInstance().searchLanguage(
				new Integer(form.getLanguage()));
		form.setLanguage(l.getId().toString());
		place.setLanguage(l);

		place.setName(form.getName());

		FormFile file = form.getPhoto();
		String fileToSavePath = SystemConstants.PLACE_IMAGES_FOLDER
				+ place.getName() + "-" + place.getLanguage().getName();

		// file handle
		if (!"".equals(form.getPhoto().getFileName())) {
			String fileType = file.getContentType();
			if (fileType.equals("image/x-png")) {
				fileToSavePath += ".png";
			} else if (fileType.equals("image/jpg")) {
				fileToSavePath += ".jpg";
			} else if (fileType.equals("image/jpeg")) {
				fileToSavePath += ".jpeg";
			} else if (fileType.equals("image/gif")) {
				fileToSavePath += ".gif";
			} else {
				return actionMapping
						.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
			}

			place.setPhoto(fileToSavePath);
			otd.setFile(file.getFileData());
			otd.setNewFile(true);
		} else {
			String fileType = place.getPhoto();

			if (fileType.contains(".png")) {
				fileToSavePath += ".png";
			} else if (fileType.contains(".jpg")) {
				fileToSavePath += ".jpg";
			} else if (fileType.contains(".jpeg")) {
				fileToSavePath += ".jpeg";
			} else if (fileType.contains(".gif")) {
				fileToSavePath += ".gif";
			}

			place.setPhoto(fileToSavePath);
			otd.setNewFile(false);
		}

		Integer categoryId = null;
		if (form.getCategory().equalsIgnoreCase("Esporte e Lazer")) {
			categoryId = new Integer(1);
		} else if (form.getCategory().equalsIgnoreCase("Restaurantes")) {
			categoryId = new Integer(2);
		} else if (form.getCategory().equalsIgnoreCase("Acomodaes")) {
			categoryId = new Integer(3);
		} else {
			categoryId = new Integer(4);
		}
		Category category = Facade.getInstance().searchCategory(categoryId);
		CategoryPlace categoryPlace = new CategoryPlace(place, category);

		Place placeSearch = Facade.getInstance().searchPlaceByName(
				place.getName(), l.getId());
		if ((placeSearch != null)
				&& (placeSearch.getId().intValue() != place.getId().intValue())) {
			return actionMapping.findForward("existSubArea");
		}

		otd.setPlace(place);
		otd.setCategoryPlace(categoryPlace);

		Collection coll = otd.getCollPlaceArea();
		otd.setCollPlaceAreaOld(coll);

		return actionMapping.findForward(SystemConstants.EXIBIR_MAPA);

	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		Integer cod = null;
		if (!"".equals(form.getLanguage())) {
			cod = new Integer(form.getLanguage());

		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = Facade.getInstance().searchLanguage(cod);

		otd.setLanguage(l);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward exibirMapa(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		form.setArrayPlaceArea(otd.retornarPlaceArea());

		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_MAP);
	}

	public ActionForward limpar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		otd.setCollPlaceArea(new ArrayList());
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_MAP);
	}

	public ActionForward cadastrarCoordenada(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		if (request.getParameter("coordx") != null
				&& !"".equals(request.getParameter("coordx"))
				&& request.getParameter("coordy") != null
				&& !"".equals(request.getParameter("coordy"))) {
			int x = Integer.parseInt(request.getParameter("coordx"));
			int y = Integer.parseInt(request.getParameter("coordy"));

			int r = Functions.getAreaRGB(x, y);
			Integer rgb = new Integer(r);

			Area area = Facade.getInstance().searchArea(rgb);
			Place place = otd.getPlace();

			PlaceArea placeArea = new PlaceArea();
			placeArea.setArea(area);
			placeArea.setPlace(place);
			placeArea.setCoordX(new Integer(x));
			placeArea.setCoordY(new Integer(y));

			Collection collPlaceArea = otd.getCollPlaceArea();
			Iterator it = collPlaceArea.iterator();
			if (collPlaceArea.isEmpty()) {
				otd.addPlaceArea(placeArea);
			} else {
				while (it.hasNext()) {
					PlaceArea pa = (PlaceArea) it.next();
					if (pa.getArea().getId().equals(area.getId())) {
						otd.addPlaceArea(placeArea);
						break;
					} else {
						form.setArrayPlaceArea(otd.retornarPlaceArea());
						return actionMapping
								.findForward(SystemConstants.ERRO_COORDENADAS);
					}
				}
			}
		}

		form.setArrayPlaceArea(otd.retornarPlaceArea());

		return actionMapping
				.findForward(SystemConstants.COORDENADAS_CADASTRADAS);
	}

	public ActionForward finish(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		Place place = otd.getPlace();
		CategoryPlace categoryPlace = otd.getCategoryPlace();
		Collection<CategoryPlace> collCategoryPlace = new ArrayList<CategoryPlace>();
		collCategoryPlace.add(categoryPlace);

		// save the file
		try {
			Place p = Facade.getInstance().searchPlace(place.getId());
			if (otd.isNewFile()) {
				Util.deleteFile(p.getPhoto());
				Util.storeFile(otd.getFile(), place.getPhoto());
			} else {
				Util.renameFile(p.getPhoto(), place.getPhoto());
			}
		} catch (IOException ioEx) {
			return actionMapping
					.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
		} catch (ExistingFileException efEx) {
			return actionMapping
					.findForward(SystemConstants.FORWARD_EXISTING_FILE);
		}

		Collection collPlaceArea = otd.getCollPlaceArea();

		if (collPlaceArea == null || collPlaceArea.isEmpty()) {
			// erro.. levantar exceo
			return actionMapping
					.findForward(SystemConstants.FORWARD_EMPTY_PLACEAREA);
		}

		Facade.getInstance().removeCategoryPlace(categoryPlace);

		Facade.getInstance().modifyPlace(place, collCategoryPlace,
				new ArrayList());

		Collection coll = otd.getCollPlaceAreaOld();
		Iterator it2 = coll.iterator();
		while (it2.hasNext()) {
			PlaceArea p = (PlaceArea) it2.next();
			Facade.getInstance().removePlaceArea(p);
		}

		Iterator it = collPlaceArea.iterator();
		while (it.hasNext()) {
			PlaceArea placeArea = (PlaceArea) it.next();
			Facade.getInstance().registerPlaceArea(placeArea);
		}

		form.limparOtd(request);

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
	}

	public ActionForward concluir(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaChangeActionForm form = (SubAreaChangeActionForm) requestActionForm;

		SubAreaChangeOTD otd = getOtd(request, form);

		Place place = otd.getPlace();
		place.setDescription(form.getDescription());
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		Language l = Facade.getInstance().searchLanguage(
				new Integer(form.getLanguage()));
		form.setLanguage(l.getId().toString());
		place.setLanguage(l);

		place.setName(form.getName());
		FormFile file = form.getPhoto();

		// file handle
		String fileToSavePath = SystemConstants.PLACE_IMAGES_FOLDER
				+ place.getName() + "-" + place.getLanguage().getName();
		String fileName = file.getFileName();
		if (!fileName.trim().equals("")) {
			String fileType = file.getContentType();
			if (fileType.equals("image/x-png")) {
				fileToSavePath += ".png";
			} else if (fileType.equals("image/jpg")) {
				fileToSavePath += ".jpg";
			} else if (fileType.equals("image/jpeg")) {
				fileToSavePath += ".jpeg";
			} else if (fileType.equals("image/gif")) {
				fileToSavePath += ".gif";
			} else {
				return actionMapping
						.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
			}

			Util.deleteFile(place.getPhoto());
			place.setPhoto(fileToSavePath);
			try {
				Util.storeFile(file.getFileData(), fileToSavePath);
			} catch (IOException ioEx) {
				return actionMapping
						.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
			}
		} else {
			String fileType = place.getPhoto();

			if (fileType.contains(".png")) {
				fileToSavePath += ".png";
			} else if (fileType.contains(".jpg")) {
				fileToSavePath += ".jpg";
			} else if (fileType.contains(".jpeg")) {
				fileToSavePath += ".jpeg";
			} else if (fileType.contains(".gif")) {
				fileToSavePath += ".gif";
			}

			Util.renameFile(place.getPhoto(), fileToSavePath);
			place.setPhoto(fileToSavePath);
		}

		Integer categoryId = null;
		if (form.getCategory().equalsIgnoreCase("Esporte e Lazer")) {
			categoryId = new Integer(1);
		} else if (form.getCategory().equalsIgnoreCase("Restaurantes")) {
			categoryId = new Integer(2);
		} else if (form.getCategory().equalsIgnoreCase("Acomodaes")) {
			categoryId = new Integer(3);
		} else {
			categoryId = new Integer(4);
		}
		Category category = Facade.getInstance().searchCategory(categoryId);

		Collection coll = Facade.getInstance().searchCategoryPlaceByPlace(
				place.getId());
		Iterator itt = coll.iterator();
		while (itt.hasNext()) {
			CategoryPlace cp = (CategoryPlace) itt.next();
			Facade.getInstance().removeCategoryPlace(cp);
		}

		CategoryPlace categoryPlace = new CategoryPlace(place, category);
		Collection collCategoryPlace = new ArrayList();
		collCategoryPlace.add(categoryPlace);

		Facade.getInstance().modifyPlace(place, collCategoryPlace,
				new ArrayList());

		form.limparOtd(request);

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
	}

	private SubAreaChangeOTD getOtd(HttpServletRequest request,
			SubAreaChangeActionForm form) {
		SubAreaChangeOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaChangeOTD)) {
			otd = new SubAreaChangeOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaChangeOTD) form.getOtd(request);
		}
		return otd;
	}
}
