package com.efetiva.wiiser.webserver.gui.subarea;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import com.efetiva.wiiser.server.entity.Area;
import com.efetiva.wiiser.server.entity.Category;
import com.efetiva.wiiser.server.entity.CategoryPlace;
import com.efetiva.wiiser.server.entity.Language;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.PlaceArea;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.exception.ExistingFileException;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.Functions;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class SubAreaRegisterAction extends ObjectAction {

	public static String USER_CASE = SubAreaRegisterAction.class
			.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaRegisterActionForm form = (SubAreaRegisterActionForm) requestActionForm;

		SubAreaRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaRegisterOTD)) {
			otd = new SubAreaRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaRegisterOTD) form.getOtd(request);
		}

		form.setName("");
		form.setDescription("");
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);

		if (collLanguage.isEmpty()) {
			request
					.getSession()
					.setAttribute("messageError",
							"Para incluir uma sub-rea  preciso ter cadastrado pelo menos um idioma");
			return actionMapping
					.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}

		Collection collAreas = Facade.getInstance().searchAllAreas();
		if (collAreas.isEmpty()) {
			request.getSession().setAttribute("messageError",
					"Nenhuma rea encontrada. Contate o administrador.");
			return actionMapping
					.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}

		Language l = null;
		if (collLanguage != null) {
			Iterator it = collLanguage.iterator();
			while (it.hasNext()) {
				l = (Language) it.next();
				break;
			}
		}
		otd.setLanguage(l);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward processar(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaRegisterActionForm form = (SubAreaRegisterActionForm) requestActionForm;

		SubAreaRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaRegisterOTD)) {
			otd = new SubAreaRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaRegisterOTD) form.getOtd(request);
		}

		Place place = new Place();
		place.setDescription(form.getDescription());
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = otd.getLanguage();
		form.setLanguage(l.getId().toString());
		place.setLanguage(l);
		place.setName(form.getName());

		// file handle
		FormFile file = form.getPhoto();
		if (file.getFileName().trim().equals("")) {
			return actionMapping
					.findForward(SystemConstants.FORWARD_EMPTY_FILE_FIELD);
		}
		String fileToSavePath = SystemConstants.PLACE_IMAGES_FOLDER
				+ place.getName() + "-" + place.getLanguage().getName();
		String fileType = file.getContentType();
		if (fileType.equals("image/x-png")) {
			fileToSavePath += ".png";
		} else if (fileType.equals("image/jpg")) {
			fileToSavePath += ".jpg";
		} else if (fileType.equals("image/jpeg")) {
			fileToSavePath += ".jpeg";
		} else if (fileType.equals("image/gif")) {
			fileToSavePath += ".gif";
		} else {
			return actionMapping
					.findForward(SystemConstants.FORWARD_INVALID_FILE_FORMAT);
		}

		place.setPhoto(fileToSavePath);
		otd.setFile(file.getFileData());

		Integer categoryId = null;
		if (form.getCategory().equalsIgnoreCase("Esporte e Lazer")) {
			categoryId = new Integer(1);
		} else if (form.getCategory().equalsIgnoreCase("Restaurantes")) {
			categoryId = new Integer(2);
		} else if (form.getCategory().equalsIgnoreCase("Acomodaes")) {
			categoryId = new Integer(3);
		} else {
			categoryId = new Integer(4);
		}
		Category category = Facade.getInstance().searchCategory(categoryId);

		CategoryPlace categoryPlace = new CategoryPlace(place, category);

		Place placeSearch = Facade.getInstance().searchPlaceByName(
				place.getName(), l.getId());

		if (placeSearch != null) {
			return actionMapping.findForward("existSubArea");
		}

		otd.setPlace(place);
		otd.setCategoryPlace(categoryPlace);

		return actionMapping.findForward(SystemConstants.EXIBIR_MAPA);

	}

	public ActionForward mudarLanguage(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaRegisterActionForm form = (SubAreaRegisterActionForm) requestActionForm;

		SubAreaRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaRegisterOTD)) {
			otd = new SubAreaRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaRegisterOTD) form.getOtd(request);
		}

		Integer cod = null;
		if (!"".equals(form.getLanguage())) {
			cod = new Integer(form.getLanguage());

		}
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = Facade.getInstance().searchLanguage(cod);

		otd.setLanguage(l);

		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward exibirMapa(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		SubAreaRegisterActionForm form = (SubAreaRegisterActionForm) requestActionForm;

		SubAreaRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaRegisterOTD)) {
			otd = new SubAreaRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaRegisterOTD) form.getOtd(request);
		}

		otd.setCollPlaceArea(new ArrayList());
		return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_MAP);
	}

	public ActionForward cadastrarCoordenada(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		SubAreaRegisterActionForm form = (SubAreaRegisterActionForm) requestActionForm;

		SubAreaRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaRegisterOTD)) {
			otd = new SubAreaRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaRegisterOTD) form.getOtd(request);
		}

		if (request.getParameter("coordx") != null
				&& !"".equals(request.getParameter("coordx"))
				&& request.getParameter("coordy") != null
				&& !"".equals(request.getParameter("coordy"))) {
			int x = Integer.parseInt(request.getParameter("coordx"));
			int y = Integer.parseInt(request.getParameter("coordy"));

			int r = Functions.getAreaRGB(x, y);
			Integer rgb = new Integer(r);

			Area area = Facade.getInstance().searchArea(rgb);
			Place place = otd.getPlace();

			PlaceArea placeArea = new PlaceArea();
			placeArea.setArea(area);
			placeArea.setPlace(place);
			placeArea.setCoordX(new Integer(x));
			placeArea.setCoordY(new Integer(y));

			Collection collPlaceArea = otd.getCollPlaceArea();
			Iterator it = collPlaceArea.iterator();
			if (collPlaceArea.isEmpty()) {
				otd.addPlaceArea(placeArea);
			} else {
				while (it.hasNext()) {
					PlaceArea pa = (PlaceArea) it.next();
					if (pa.getArea().getId().equals(area.getId())) {
						otd.addPlaceArea(placeArea);
						break;
					} else {
						form.setArrayPlaceArea(otd.retornarPlaceArea());
						return actionMapping
								.findForward(SystemConstants.ERRO_COORDENADAS);
					}
				}
			}
		}
		form.setArrayPlaceArea(otd.retornarPlaceArea());

		return actionMapping
				.findForward(SystemConstants.COORDENADAS_CADASTRADAS);
	}

	public ActionForward finish(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		SubAreaRegisterActionForm form = (SubAreaRegisterActionForm) requestActionForm;

		SubAreaRegisterOTD otd = null;
		if (!(form.getOtd(request) instanceof SubAreaRegisterOTD)) {
			otd = new SubAreaRegisterOTD();
			form.setOtd(otd, request);
		} else {
			otd = (SubAreaRegisterOTD) form.getOtd(request);
		}

		Place place = otd.getPlace();
		Language language = otd.getLanguage();
		CategoryPlace categoryPlace = otd.getCategoryPlace();
		Collection<CategoryPlace> collCategoryPlace = new ArrayList<CategoryPlace>();
		collCategoryPlace.add(categoryPlace);

		Collection collPlaceArea = otd.getCollPlaceArea();

		if (collPlaceArea == null || collPlaceArea.isEmpty()) {
			// erro.. levantar exceo
			return actionMapping
					.findForward(SystemConstants.FORWARD_EMPTY_PLACEAREA);
		}

		// save the file
		try {
			Util.storeFile(otd.getFile(), place.getPhoto());
		} catch (IOException ioEx) {
			return actionMapping
					.findForward(SystemConstants.FORWARD_PROBLEM_SAVE_FILE);
		} catch (ExistingFileException efEx) {
			return actionMapping
					.findForward(SystemConstants.FORWARD_EXISTING_FILE);
		}

		Facade.getInstance().registerPlace(place, collCategoryPlace,
				new ArrayList());

		Place place2 = Facade.getInstance().searchPlaceByName(place.getName(),
				language.getId());
		if (place2 == null) {
			// erro... levantar exceo
			return actionMapping
					.findForward(SystemConstants.FORWARD_PROBLEM_STORING_PLACE);
		}

		Iterator it = collPlaceArea.iterator();
		while (it.hasNext()) {
			PlaceArea placeArea = (PlaceArea) it.next();
			placeArea.setPlace(place2);
			Facade.getInstance().registerPlaceArea(placeArea);
		}

		form.setName("");
		form.setDescription("");
		Collection collLanguage = Facade.getInstance().searchAllLanguages();
		form.setCollLanguage(collLanguage);
		Language l = null;
		if (collLanguage != null) {
			Iterator it1 = collLanguage.iterator();
			while (it1.hasNext()) {
				l = (Language) it1.next();
				break;
			}

		}
		otd.setLanguage(l);

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);

	}
}
