package com.efetiva.wiiser.webserver.gui.subarea;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.Activity;
import com.efetiva.wiiser.server.entity.CategoryPlace;
import com.efetiva.wiiser.server.entity.Place;
import com.efetiva.wiiser.server.entity.PlaceArea;
import com.efetiva.wiiser.server.entity.ScheduleService;
import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class SubAreaRemoveAction extends ObjectAction {

	public static String USER_CASE = SubAreaRemoveAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		int placeId = Integer.parseInt(request.getParameter("placeId"));
		
		// Verifica se existem atividades com essa sub-rea 
		Collection activitiesByPlace = Facade.getInstance().searchActivityByPlace(placeId);
		if(!activitiesByPlace.isEmpty()){
			request.getSession().setAttribute("messageError", "Existem atividades com essa sub-rea. Remova-as primeiro.");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		// Verifica se existem servios com essa sub-rea 
		Collection servicesByPlace = Facade.getInstance().searchServiceByPlace(placeId);
		if(!servicesByPlace.isEmpty()){
			request.getSession().setAttribute("messageError", "Existem servios com essa sub-rea. Remova-os primeiro.");
			return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
		}
		
		Place place = Facade.getInstance().searchPlace(placeId);
		if (place != null) {
			//remove categoryPlaces
			Collection categoryPlaces = Facade.getInstance().searchCategoryPlaceByPlace(place.getId());
			Iterator iterator = categoryPlaces.iterator();
			while (iterator.hasNext()) {
				CategoryPlace categoryPlace = (CategoryPlace) iterator.next();
				Facade.getInstance().removeCategoryPlace(categoryPlace);
			}
			
			//remove placearea
			Collection placeAreas = Facade.getInstance().searchPlaceAreasByPlace(place.getId());
			iterator = placeAreas.iterator();
			while (iterator.hasNext()) {
				PlaceArea placeArea = (PlaceArea) iterator.next();
				Facade.getInstance().removePlaceArea(placeArea);
			}
			
			//remove the file
			Util.deleteFile(place.getPhoto());
			//remove the place
			Facade.getInstance().removePlace(place);
		}
		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}
}
