package com.efetiva.wiiser.webserver.gui.user;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class UserChangePassAction extends ObjectAction {
	public static String USER_CASE = UserChangePassAction.class.getSimpleName()
	+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);

		UserChangePassActionForm form = (UserChangePassActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);
		form.setUsername(userSession.getUsername());
		form.setPassword("");
		form.setNewPassword("");
		form.setNewPasswordConfirm("");
		return actionMapping
		.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		UserChangePassActionForm form = (UserChangePassActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);
		return actionMapping
		.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);

		UserChangePassActionForm form = (UserChangePassActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		String username = form.getUsername();
		if(userSession.getPermission().equals(User.ADMINISTRATOR)){
			User user = Facade.getInstance().searchUser(username);
			if(!username.trim().equals("")){
				String password = Util.criptografar(form.getPassword());
				if((user != null) && (password.equals(user.getPassword()))){
					String newPassword = form.getNewPassword();
					if((newPassword.length() > 3) && (newPassword.length() <= 10)){
						String newPasswordConfirm = form.getNewPasswordConfirm();
						if(newPassword.equals(newPasswordConfirm)){
							user.setPassword(Util.criptografar(newPassword));
							Facade.getInstance().modifyUser(user);
						} else {
							form.setPassword("");
							form.setNewPassword("");
							form.setNewPasswordConfirm("");
							return actionMapping.findForward(SystemConstants.FOWARD_ERROR_PASSWORD_CONFIRM);
						}
					} else {
						form.setPassword("");
						form.setNewPassword("");
						form.setNewPasswordConfirm("");
						return actionMapping.findForward(SystemConstants.FORWARD_ERROR_PASSWORD_SIZE);
					}
				} else {
					form.setPassword("");
					form.setNewPassword("");
					form.setNewPasswordConfirm("");
					return actionMapping.findForward(SystemConstants.FORWARD_WRONG_USER);
				}
			} else {
				return actionMapping.findForward(SystemConstants.FORWARD_EMPTY_LOGIN);
			}

		} else {
			form.setUsername("");
			form.setPassword("");
			form.setNewPassword("");
			form.setNewPasswordConfirm("");
			return actionMapping.findForward(SystemConstants.FORWARD_DENIED_USER);
		}

		form.setUsername(form.getUsername());
		form.setPassword("");
		form.setNewPassword("");
		form.setNewPasswordConfirm("");

		return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);


	}
}
