package com.efetiva.wiiser.webserver.gui.user;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class UserLoginAction extends ObjectAction {
	public static String USER_CASE = UserLoginAction.class.getSimpleName()
			+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		UserLoginActionForm form = (UserLoginActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);
		form.setUsername("");
		form.setPassword("");
		return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
	}

	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		UserLoginActionForm form = (UserLoginActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);
		return actionMapping
				.findForward("index");
	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		UserLoginActionForm form = (UserLoginActionForm) requestActionForm;
		form.setDoAction(SystemConstants.PROCESS);

		//implementao de usurio
		boolean correctUser = false;
		User user = Facade.getInstance().searchUser(form.getUsername());
		
		if (user != null){
			String password = Util.criptografar(form.getPassword());
			if (user.getPassword().equals(password)){
				correctUser = true;
			}
		}
		
		if (correctUser == false) {
			form.setUsername("");
			form.setPassword("");
			return actionMapping
					.findForward(SystemConstants.FORWARD_WRONG_USER);
			
		}

		request.getSession().setAttribute(SystemConstants.USER, user);

		return actionMapping.findForward(SystemConstants.FORWARD_START_SCREEN);

	}

}
