package com.efetiva.wiiser.webserver.gui.user;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class UserModifyAction extends ObjectAction {

	public static String USER_CASE = UserModifyAction.class.getSimpleName()
	+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);
		
		if(request.getSession().getAttribute(SystemConstants.USER) != null){
			if(userSession.getPermission().equals(User.ADMINISTRATOR)){
				UserModifyActionForm form = (UserModifyActionForm) requestActionForm;
				form.setDoAction(SystemConstants.PROCESS);
				
				form.setUsername(request.getParameter("login"));
				User user = Facade.getInstance().searchUser(form.getUsername());
				form.setPermission(user.getPermission());
				
				return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
			}else{
				request.getSession().setAttribute("messageError", "Voc nao possue permisso de administrador.");
				return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
			}
		}else {
			return actionMapping.findForward(SystemConstants.FORWARD_NOT_LOGGED);
		}
	}
	@SuppressWarnings("unused")
	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		if(request.getSession().getAttribute(SystemConstants.USER) != null){
			
			UserModifyActionForm form = (UserModifyActionForm) requestActionForm;
	
			return actionMapping
			.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_LOGGED);
		}
	}
	
	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);
		
		if(request.getSession().getAttribute(SystemConstants.USER) != null){
			if(userSession.getPermission().equals(User.ADMINISTRATOR)){
				UserModifyActionForm form = (UserModifyActionForm) requestActionForm;
	
				User user = Facade.getInstance().searchUser(form.getUsername());
				if (user != null){
					String temp = "Administrador";
					if (form.getPermission().equals(temp)){
						user.setPermission(User.ADMINISTRATOR);
					} else {
						user.setPermission(User.MANAGER);
					}
					Facade.getInstance().modifyUser(user);
				}
				return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
			}else {
				request.getSession().setAttribute("messageError", "Voc nao possue permisso de administrador.");
				return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
			}
			
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_LOGGED);
		}
	}
	
}
