package com.efetiva.wiiser.webserver.gui.user;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.gui.util.Util;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class UserRegisterAction extends ObjectAction {

	public static String USER_CASE = UserRegisterAction.class.getSimpleName()
	+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);

		if(userSession != null){
			if(userSession.getPermission().equals(User.ADMINISTRATOR)){
				UserRegisterActionForm form = (UserRegisterActionForm) requestActionForm;
				//form.setDoAction(SystemConstants.PROCESS);
				form.setLogin("");
				form.setPassword("");
				form.setPasswordConfirm("");
				//request.setAttribute("msg", request.getAttribute("msg"));
				return actionMapping
				.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
			}else {
				request.getSession().setAttribute("messageError", "Voc nao possue permisso de administrador.");
				return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
			}
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_LOGGED);
		}
	}
	@SuppressWarnings("unused")
	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

	
		UserRegisterActionForm form = (UserRegisterActionForm) requestActionForm;
		//form.setDoAction(SystemConstants.PROCESS);
		return actionMapping
		.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward register(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);

		if(userSession != null){
			if(!userSession.getPermission().equals(User.ADMINISTRATOR)){
				request.getSession().setAttribute("messageError", "Voc nao possue permisso de administrador.");
				return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
			}

			UserRegisterActionForm form = (UserRegisterActionForm) requestActionForm;
			//form.setDoAction(SystemConstants.PROCESS);

			//implementao de usurio
			String username = form.getLogin();

			if(!username.trim().equals("")){
				User user = Facade.getInstance().searchUser(username);

				if (user == null){

					String password = form.getPassword();
					String passwordConfirm = form.getPasswordConfirm();
					String permission = "";
					String temp = "Administrador";
					if (form.getPermission().equals(temp)){
						permission = User.ADMINISTRATOR;
					} else {
						permission = User.MANAGER;
					}

					if(password.equals(passwordConfirm)){
						if((password.length() > 3) && (password.length() <= 10)){
							User newUser = new User();
							newUser.setUsername(form.getLogin());
							newUser.setPassword(Util.criptografar(password));
							newUser.setPermission(permission);
							Facade.getInstance().registerUser(newUser);

							form.setLogin("");
							form.setPassword("");
							form.setPasswordConfirm("");
							//request.setAttribute("msg", "2");
							return actionMapping.findForward(SystemConstants.FORWARD_SUCESS_SCREEN);
						} else {
							form.setPassword("");
							form.setPasswordConfirm("");
							//request.setAttribute("msg", "3");
							return actionMapping.findForward(SystemConstants.FORWARD_ERROR_PASSWORD_SIZE);
						}
					}else{
						form.setPassword("");
						form.setPasswordConfirm("");
						//request.setAttribute("msg", "4");
						return actionMapping
						.findForward(SystemConstants.FOWARD_ERROR_PASSWORD_CONFIRM);
					}

				}else{
					form.setLogin("");
					form.setPassword("");
					form.setPasswordConfirm("");
					//request.setAttribute("msg", "1");
					return actionMapping
					.findForward(SystemConstants.FOWARD_EXIST_USER);
				}

			} else {
				//request.setAttribute("msg", "5");
				return actionMapping.findForward(SystemConstants.FORWARD_EMPTY_LOGIN);
			}
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_LOGGED);
		}
	}
}
