package com.efetiva.wiiser.webserver.gui.user;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.efetiva.wiiser.server.entity.User;
import com.efetiva.wiiser.server.singleton.Facade;
import com.efetiva.wiiser.webserver.gui.util.ObjectAction;
import com.efetiva.wiiser.webserver.util.SystemConstants;

public class UserRemoveAction extends ObjectAction {

	public static String USER_CASE = UserRemoveAction.class.getSimpleName()
	+ SystemConstants.USER_CASE_EXTENSION;

	public ActionForward exhibit(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		return actionMapping
		.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward refresh(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		return actionMapping
		.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);

	}

	public ActionForward process(ActionMapping actionMapping,
			ActionForm requestActionForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		User userSession = (User) request.getSession().getAttribute(
				SystemConstants.USER);

		if(userSession != null){
			if(userSession.getPermission().equals(User.ADMINISTRATOR)){
				User user = Facade.getInstance().searchUser(request.getParameter("login"));
				if(user != null){
					Facade.getInstance().removeUser(user);
				}
				return actionMapping.findForward(SystemConstants.FORWARD_DYSPLAY_SCREEN);
			} else {
				request.getSession().setAttribute("messageError", "Voc nao possue permisso de administrador.");
				return actionMapping.findForward(SystemConstants.FORWARD_ERROR_SCREEN);
			}
		} else {
			return actionMapping
			.findForward(SystemConstants.FORWARD_NOT_LOGGED);
		}

	}
}
