package com.efetiva.wiiser.webserver.gui.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import javax.servlet.http.HttpServletRequest;

import com.efetiva.wiiser.webserver.exception.ExistingFileException;

public class Util {

	public static String getUrlBase(HttpServletRequest req) {
		String protocolo = req.getProtocol();
		int i = protocolo.indexOf("/");
		if (i != -1) {
			protocolo = protocolo.substring(0, i);
		}
		//int numeroPorta = req.getServerPort();
		String porta = ":8080";

		return protocolo + "://" + req.getServerName() + porta
				+ req.getContextPath();
	}
	
	public static void storeFile(byte[] file, String fileName) throws IOException, ExistingFileException{
		File f = new File(fileName);
		
		//if(!f.exists()){
			f.createNewFile();
		//} else {
		//	throw new ExistingFileException();
		//}
		
		FileOutputStream fos = new FileOutputStream(f);
		fos.write(file);
		fos.close();
	}
	
	public static void deleteFile(String fileName){
		File f = new File(fileName);
		f.delete();
	}
	
	public static void renameFile(String oldfileName, String newFileName){
		File oldFile = new File(oldfileName);
		File newFile = new File(newFileName);
		oldFile.renameTo(newFile);
	}
	
	public static String criptografar(String pwd) {

		MessageDigest md = null;
		try {
			md = MessageDigest.getInstance ("MD5");
		} catch (NoSuchAlgorithmException ex) {
			ex.printStackTrace();
		}
		if (md != null) {
			byte[] text = md.digest (pwd.getBytes());
			char[] hexOutput = new char[text.length * 2];
			String hexString;
			for (int i = 0; i < text.length ; i++) {
				hexString = "00" + Integer.toHexString(text[i]);
				hexString.toUpperCase().getChars( hexString.length() - 2,
						hexString.length(), hexOutput, i * 2);
			}
			return new String(hexOutput);
		}
		return null;
	}
	
}
