package com.efetiva.wiiser.webserver.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Hashtable;

import com.efetiva.wiiser.webserver.exception.ServiceLocatorException;

public class ServiceLocator {

	private static ServiceLocator instancia;

	private static Hashtable hs;

	private ServiceLocator() {
	}

	static {
		hs = new Hashtable();
	}

	public static ServiceLocator getIntancia() {
		if (instancia == null) {
			instancia = new ServiceLocator();
		}
		return instancia;
	}

	public Object getClasse(String nome) throws ServiceLocatorException {
		Object retorno;
		if (hs.containsKey(nome)) {
			retorno = hs.get(nome);
		} else {
			retorno = carregaClasse(nome);
		}
		return retorno;
	}

	private Object carregaClasse(String nome) throws ServiceLocatorException {
		Object classe = null;
		Class classAuxiliar = null;
		Method metodo = null;
		try {
			classAuxiliar = Class.forName(nome.trim());
			metodo = classAuxiliar.getMethod("getInstancia", null);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			throw new ServiceLocatorException(e);
		} catch (NoSuchMethodException e) {
			try {
				metodo = classAuxiliar.getMethod("getInstance", null);
			} catch (NoSuchMethodException ex) {
				ex.printStackTrace();
				throw new ServiceLocatorException(ex);
			}
		} catch (Throwable e) {
			e.printStackTrace();
		}

		try {
			classe = metodo.invoke(null, null);
		} catch (IllegalAccessException e) {
			e.printStackTrace();
			throw new ServiceLocatorException(e);
		} catch (InvocationTargetException e) {
			e.printStackTrace();
			throw new ServiceLocatorException(e);
		}
		hs.put(nome, classe);
		return classe;
	}
}
